/*
 * Copyright (c) 2005-2006 ISP RAS.
 * 109004, B. Communisticheskaya, 25, Moscow, Russia.
 * All rights reserved.
 *
 * $Id: Account.java,v 1.1 2007/11/22 14:47:11 almo Exp $
 */

package jatva.examples.account;

/**
 * The <CODE>Account</CODE> class presents a simple account
 * that can store an integer value of balance in thousands
 * dollars.
 *
 * <p>This class provides two methods: one to deposit some money
 * to this account and the other to withdraw a sum.</p>
 *
 * @author Victor Kuliamin
 * @version 1.0
 */
public class Account
{
  /**
   * The value opposite to the minimum possible balance of an account.
   */    
  static public int maximumCredit = 3;
  
  /**
   * The balance of the account.
   */  
  public int balance = 0;
  
  /**
   * Creates an empty <CODE>Account</CODE> object.
   */  
  public Account()
  {
  }
  
  /**
   * Deposits the <CODE>sum</CODE> to the account.
   *
   * @param sum the sum to be deposited. Should be more than <CODE>0</CODE>.
   */  
  public void deposit(int sum)
  {
    balance += sum;
  }
  
  /**
   * Withdraws the <CODE>sum</CODE> from the account.
   *
   * @param sum the sum to be withdrawn. Should be more than <CODE>0</CODE>.
   * @return <CODE>0</CODE>, if the <CODE>sum</CODE> exceeds
   *        the <CODE>balance</CODE> on more than <CODE>maximumCredit</CODE>.
   *        The value equal to <CODE>sum</CODE>, if the <CODE>sum</CODE> does
   *        not exceed the <CODE>balance</CODE> or exceeds it on less than
   *        <CODE>maximumCredit</CODE>.
   */  
  public int withdraw(int sum)
  {
    if(balance < sum - maximumCredit)
    {
      return 0;
    }
    else
    {
      balance -= sum;
      return sum;
    }
  }
}
