/*
 * Copyright (c) 2005-2006 ISP RAS.
 * 109004, B. Communisticheskaya, 25, Moscow, Russia.
 * All rights reserved.
 *
 * $Id: Queue.java,v 1.1 2007/11/22 14:51:57 almo Exp $
 * Modified on   06.03.2006
 * First version 01.04.2001
 * 
 */

package jatva.examples.queue;

/**
 *  The implementation of the queue with priorities.
 *  Priorities are represented as integers between MIN_Priority and MAX_Priority
 */

public class Queue<T>
{
  public List<T> items = new List<T>();
  
  public Queue()
  {
  }
  
  public final synchronized boolean isEmpty()
  {
    return items.size() == 0;
  }
  
  public final synchronized void enq(T obj)
  {
    items.addLast(obj);
  }
  
  public synchronized T deq()
  {
    if(items.size() == 0) return null;
    else
    {
      T r = items.first();
      items.removeFirst();
      return r;
    }
  }
}