/*
 * Copyright (c) 2000 ISP RAS.
 * 109004, B. Communisticheskaya, 25, Moscow, Russia.
 * All rights reserved.
 *
 * $Id: NondeterministicModelException.java,v 1.4 2006/03/30 15:18:40 kuliamin Exp $
 * Created on 01.04.2000
 *
 */

package jatva.engines;

import jatva.lang.TestEngineException;

public class NondeterministicModelException
  extends TestEngineException
{
  public NondeterministicModelException(  String scenarioClass
                                        , Object prevState
                                        , int transition
                                        , Object oldState
                                        , Object currentState
                                       )
  {
    super(  "The scenario defines nondeterministic model" 
          , new String[]{"scenario class", "previous state", "transition", "old transition end", "current transitions end"}
          , new String[]{scenarioClass, "" + prevState, "" + transition, "" + oldState, "" + currentState}
         );
  }

  public NondeterministicModelException(  String info
                                        , String scenarioClass
                                        , Object prevState
                                        , int transition
                                        , Object oldState
                                        , Object currentState
                                       )
  {
    super (  info 
           , new String[]{"scenario class", "previous state", "transition", "old transition end", "current transitions end"}
           , new String[]{scenarioClass, "" + prevState, "" + transition, "" + oldState, "" + currentState}
          );
  }
}
