package jatva.iterators.lang;

import jatva.iterators.AbstractIterator;
import jatva.util.ObjectIntPair;

public abstract class AbstractObjectIntPairIterator
  extends AbstractIterator
  implements IObjectIntPairIterator
{
  abstract public Object  value1();
  abstract public int     value2();
  abstract public Object  clone();
  abstract public boolean stop();
  abstract public void    shift();
  abstract public boolean equals(Object o);
  abstract public int     hashCode();
  
  public Object next()
  {
    Object r = new ObjectIntPair(value1(), value2());
    shift();
    return r;    
  }
  
  public String toString()
  {
    if(stop()) return jatva.iterators.Iterator.EXHAUSTED;
    return "(" + value1() + ", " + value2() + ")";
  }
}
