/* 
 * Copyright (c) 2000 ISP RAS.
 * B.Communisticheskaya,25, Moscow, Russia.
 * All rights reserved.
 *
 */

package jatva.iterators.lang;

public class ArrayByteIterator
  extends    AbstractByteIterator
  implements IByteIterator
{
  protected byte[] values = ByteIterator.defaultValues;
  protected int index = 0;
  
  public ArrayByteIterator()
  {
  }
  
  public ArrayByteIterator(byte[] values)
  {
    if(values != null) this.values = values;
    else               this.values = new byte[0];
  }
  
  public ArrayByteIterator(ArrayByteIterator r)
  {
    if(r != null) 
    {
      values = r.values;
      index  = r.index;
    }
    else values = new byte[0];
  }

  public Object clone()
  {
    return new ArrayByteIterator(this);
  }
  
  public boolean equals(Object o)
  {
    if(!(o instanceof ArrayByteIterator))
      return false;

    ArrayByteIterator obj = (ArrayByteIterator)o;

    if(index != obj.index) return false;
    if(values.length != obj.values.length) return false;
    
    for(int i = 0; i < values.length; i++)
      if(values[i] != obj.values[i]) return false;
    
    return true;   
  }
  
  public byte value()
  {
    return values[index];
  }
  
  public boolean stop()
  {
    return index >= values.length;
  }
  
  public void shift()
  {
    index++;
  }

  public int hashCode()
  {
    int r = 113*index;
    for(int i = 0; i < values.length; i++)
    { 
      r *= 3;
      r += values[i];   
    }
    
    return r;
  }
}
