/* 
 * Copyright (c) 2000 ISP RAS.
 * B.Communisticheskaya,25, Moscow, Russia.
 * All rights reserved.
 *
 */

package jatva.iterators.lang;

public class ArrayCharacterIterator
  extends    AbstractCharacterIterator
  implements ICharacterIterator
{
  protected char[] values = CharacterIterator.defaultValues;
  protected int index = 0;
  
  public ArrayCharacterIterator()
  {
  }
  
  public ArrayCharacterIterator(char[] values)
  {
    if(values != null) this.values = values;
    else               this.values = new char[0];
  }
  
  public ArrayCharacterIterator(ArrayCharacterIterator r)
  {
    if(r != null) 
    {
      values = r.values;
      index  = r.index;
    }
    else values = new char[0];
  }

  public Object clone()
  {
    return new ArrayCharacterIterator(this);
  }
  
  public boolean equals(Object o)
  {
    if(!(o instanceof ArrayCharacterIterator))
      return false;

    ArrayCharacterIterator obj = (ArrayCharacterIterator)o;

    if(index != obj.index) return false;
    if(values.length != obj.values.length) return false;
    
    for(int i = 0; i < values.length; i++)
      if(values[i] != obj.values[i]) return false;
    
    return true;   
  }
  
  public char value()
  {
    return values[index];
  }
  
  public boolean stop()
  {
    return index >= values.length;
  }
  
  public void shift()
  {
    index++;
  }

  public int hashCode()
  {
    int r = 113*index;
    for(int i = 0; i < values.length; i++)
    { 
      r *= 3;
      r += values[i];   
    }
    
    return r;
  }
}
