/* 
 * Copyright (c) 2000 ISP RAS.
 * B.Communisticheskaya,25, Moscow, Russia.
 * All rights reserved.
 *
 */

package jatva.iterators.lang;

public class ArrayDoubleIterator
  extends    AbstractDoubleIterator
  implements IDoubleIterator
{
  protected double[] values = DoubleIterator.defaultValues;
  protected int index = 0;
  
  public ArrayDoubleIterator()
  {
  }
  
  public ArrayDoubleIterator(double[] values)
  {
    if(values != null) this.values = values;
    else               this.values = new double[0];
  }
  
  public ArrayDoubleIterator(ArrayDoubleIterator r)
  {
    if(r != null) 
    {
      values = r.values;
      index  = r.index;
    }
    else values = new double[0];
  }

  public Object clone()
  {
    return new ArrayDoubleIterator(this);
  }
  
  public boolean equals(Object o)
  {
    if(!(o instanceof ArrayDoubleIterator))
      return false;

    ArrayDoubleIterator obj = (ArrayDoubleIterator)o;

    if(index != obj.index) return false;
    if(values.length != obj.values.length) return false;
    
    for(int i = 0; i < values.length; i++)
    {
      if(Double.isNaN(values[i]) && Double.isNaN(obj.values[i])) continue;
      if(values[i] != obj.values[i]) return false;
    }
    
    return true;   
  }
  
  public double value()
  {
    return values[index];
  }
  
  public boolean stop()
  {
    return index >= values.length;
  }
  
  public void shift()
  {
    index++;
  }

  public int hashCode()
  {
    int r = 113*index;
    for(int i = 0; i < values.length; i++)
    { 
      r *= 3;
      r += values[i];   
    }
    
    return r;
  }
}
