/* 
 * Copyright (c) 2000 ISP RAS.
 * B.Communisticheskaya,25, Moscow, Russia.
 * All rights reserved.
 *
 */

package jatva.iterators.lang;

public class ArrayFloatIterator
  extends    AbstractFloatIterator
  implements IFloatIterator
{
  protected float[] values = FloatIterator.defaultValues;
  protected int index = 0;
  
  public ArrayFloatIterator()
  {
  }
  
  public ArrayFloatIterator(float[] values)
  {
    if(values != null) this.values = values;
    else               this.values = new float[0];
  }
  
  public ArrayFloatIterator(ArrayFloatIterator r)
  {
    if(r != null) 
    {
      values = r.values;
      index  = r.index;
    }
    else values = new float[0];
  }

  public Object clone()
  {
    return new ArrayFloatIterator(this);
  }
  
  public boolean equals(Object o)
  {
    if(!(o instanceof ArrayFloatIterator))
      return false;

    ArrayFloatIterator obj = (ArrayFloatIterator)o;

    if(index != obj.index) return false;
    if(values.length != obj.values.length) return false;
    
    for(int i = 0; i < values.length; i++)
    {
      if(Float.isNaN(values[i]) && Float.isNaN(obj.values[i])) continue;
      if(values[i] != obj.values[i]) return false;
    }
    
    return true;   
  }
  
  public float value()
  {
    return values[index];
  }
  
  public boolean stop()
  {
    return index >= values.length;
  }
  
  public void shift()
  {
    index++;
  }

  public int hashCode()
  {
    int r = 113*index;
    for(int i = 0; i < values.length; i++)
    { 
      r *= 3;
      r += values[i];   
    }
    
    return r;
  }
}
