/* 
 * Copyright (c) 2000 ISP RAS.
 * B.Communisticheskaya,25, Moscow, Russia.
 * All rights reserved.
 *
 */

package jatva.iterators.lang;

public class ArrayIntegerIterator
  extends    AbstractIntegerIterator
  implements IIntegerIterator
{
  protected int[] values = IntegerIterator.defaultValues;
  protected int index = 0;
  
  public ArrayIntegerIterator()
  {
  }
  
  public ArrayIntegerIterator(int[] values)
  {
    if(values != null) this.values = values;
    else               this.values = new int[0];
  }
  
  public ArrayIntegerIterator(ArrayIntegerIterator r)
  {
    if(r != null) 
    {
      values = r.values;
      index  = r.index;
    }
    else values = new int[0];
  }

  public Object clone()
  {
    return new ArrayIntegerIterator(this);
  }
  
  public boolean equals(Object o)
  {
    if(!(o instanceof ArrayIntegerIterator))
      return false;

    ArrayIntegerIterator obj = (ArrayIntegerIterator)o;

    if(index != obj.index) return false;
    if(values.length != obj.values.length) return false;
    
    for(int i = 0; i < values.length; i++)
      if(values[i] != obj.values[i]) return false;
    
    return true;   
  }
  
  public int value()
  {
    return values[index];
  }
  
  public boolean stop()
  {
    return index >= values.length;
  }
  
  public void shift()
  {
    index++;
  }

  public int hashCode()
  {
    int r = 113*index;
    for(int i = 0; i < values.length; i++)
    { 
      r *= 3;
      r += values[i];   
    }
    
    return r;
  }
}
