/* 
 * Copyright (c) 2000 ISP RAS.
 * B.Communisticheskaya,25, Moscow, Russia.
 * All rights reserved.
 *
 */

package jatva.iterators.lang;

public class ArrayStringIterator
  extends    AbstractStringIterator
  implements IStringIterator
{
  protected String[] values = StringIterator.defaultValues;
  protected int index = 0;
  
  public ArrayStringIterator()
  {
  }
  
  public ArrayStringIterator(String[] values)
  {
    if(values != null) this.values = values;
    else               this.values = new String[0];
  }
  
  public ArrayStringIterator(ArrayStringIterator r)
  {
    if(r != null) 
    {
      index  = r.index;
      values = new String[r.values.length];
      
      System.arraycopy(r.values, 0, values, 0, values.length);
    }
    else values = new String[0];
  }

  public void addString(String n)
  {
    String[] newValues = new String[values.length+1];
    System.arraycopy(values, 0, newValues, 0, values.length);
    newValues[values.length] = n;
    values = newValues;
  }
 
  public Object clone()
  {
    return new ArrayStringIterator(this);
  }
  
  public boolean equals(Object o)
  {
    if(!(o instanceof ArrayStringIterator))
      return false;

    ArrayStringIterator obj = (ArrayStringIterator)o;

    if(index != obj.index) return false;
    if(values.length != obj.values.length) return false;
    
    for(int i = 0; i < values.length; i++)
      if(   values[i] == null && obj.values[i] != null
         || values[i] != null && !values[i].equals(obj.values[i])
        ) return false;
    
    return true;   
  }
  
  public String value()
  {
    return values[index];
  }
  
  public boolean stop()
  {
    return index >= values.length;
  }
  
  public void shift()
  {
    index++;
  }

  public int hashCode()
  {
    int r = 113*index;
    for(int i = 0; i < values.length; i++)
    { 
      r *= 3;
      r += (values[i] == null)?0:values[i].hashCode();   
    }
    
    return r;
  }
}
