/* 
 * Copyright (c) 2000 ISP RAS.
 * B.Communisticheskaya,25, Moscow, Russia.
 * All rights reserved.
 *
 */

package jatva.iterators.lang;

import jatva.iterators.AbstractIterator;

public class BooleanIterator
  extends    AbstractIterator
  implements jatva.iterators.Iterator
{
  protected int index = 0;
  
  public BooleanIterator()
  {
  }
  
  public BooleanIterator(BooleanIterator right)
  {
    index = right.index;
  }
  
  public synchronized Object clone()
  {
    return new BooleanIterator(this);
  }
  
  public synchronized void shift()
  {
    index++;
  }
  
  public boolean value()
  {
    return (index == 0);
  }
  
  public boolean stop()
  {
    return index >= 2;
  }

  public boolean equals(Object o) 
  {
    if(!(o instanceof BooleanIterator))
      return false;

    return index == ((BooleanIterator)o).index;
  }

  public String toString()
  {
    if(stop()) return jatva.iterators.Iterator.EXHAUSTED;
    return "" + value();
  }
  
  public int hashCode()
  {
    return index;
  }

  public Object next()
  {
    Object r = new Boolean(value());
    shift();
    return r;
  }

}
