/* 
 * Copyright (c) 2000 ISP RAS.
 * B.Communisticheskaya,25, Moscow, Russia.
 * All rights reserved.
 *
 */

package jatva.iterators.lang;

public class NeighbourhoodByteIterator
  extends    AbstractByteIterator
  implements IByteIterator
{
  protected byte point = 0;
  protected int offset = 0;
  protected int index  = 0;
  
  public NeighbourhoodByteIterator(byte point, int offset)
  {
    int m = Math.max(Byte.MAX_VALUE - point, point - Byte.MIN_VALUE);
    if(offset > m) offset = m;
    if(offset < 0) offset = 0;
     
    this.point  = point;
    this.offset = offset;
  }

  public NeighbourhoodByteIterator(byte point)
  {
    this(point, 0);
  }
  
  public NeighbourhoodByteIterator(NeighbourhoodByteIterator r)
  {
    this.point  = r.point;
    this.offset = r.offset;
    this.index  = r.index;
  }

  public Object clone()
  {
    return new NeighbourhoodByteIterator(this);
  }
  
  public boolean equals(Object o)
  {
    if(!(o instanceof NeighbourhoodByteIterator))
      return false;

    NeighbourhoodByteIterator obj = (NeighbourhoodByteIterator)o;

    return    index  == obj.index 
           && point  == obj.point
           && offset == obj.offset;
  }
  
  public byte value()
  {
    return (byte)(point + ((index%2 == 0)?(index/2):(-(index+1)/2)));
  }
  
  public boolean stop()
  {
    return index > 2*offset;
  }
  
  public void shift()
  {
    index++;
    
    if(      index%2 == 0
          && point > Byte.MAX_VALUE - index/2
       ||    index%2 == 1
          && point < Byte.MIN_VALUE + (index+1)/2
      )
      index++;
  }

  public int hashCode ()
  {
    return index + 3*point + 11*offset;
  }
}
