/* 
 * Copyright (c) 2000 ISP RAS.
 * B.Communisticheskaya,25, Moscow, Russia.
 * All rights reserved.
 *
 */

package jatva.iterators.lang;

public class NeighbourhoodCharacterIterator
  extends    AbstractCharacterIterator
  implements ICharacterIterator
{
  protected char point = 0;
  protected int offset = 0;
  protected int index  = 0;
  
  public NeighbourhoodCharacterIterator(char point, int offset)
  {
    int m = Math.max(Character.MAX_VALUE - point, point - Character.MIN_VALUE);
    if(offset > m) offset = m;
    if(offset < 0) offset = 0;
     
    this.point  = point;
    this.offset = offset;
  }

  public NeighbourhoodCharacterIterator(char point)
  {
    this(point, 0);
  }
  
  public NeighbourhoodCharacterIterator(NeighbourhoodCharacterIterator r)
  {
    this.point  = r.point;
    this.offset = r.offset;
    this.index  = r.index;
  }

  public Object clone()
  {
    return new NeighbourhoodCharacterIterator(this);
  }
  
  public boolean equals(Object o)
  {
    if(!(o instanceof NeighbourhoodCharacterIterator))
      return false;

    NeighbourhoodCharacterIterator obj = (NeighbourhoodCharacterIterator)o;

    return    index  == obj.index 
           && point  == obj.point
           && offset == obj.offset;
  }
  
  public char value()
  {
    return (char)(point + ((index%2 == 0)?(index/2):(-(index+1)/2)));
  }
  
  public boolean stop()
  {
    return index > 2*offset;
  }
  
  public void shift()
  {
    index++;
    
    if(      index%2 == 0
          && point > Character.MAX_VALUE - index/2
       ||    index%2 == 1
          && point < Character.MIN_VALUE + (index+1)/2
      )
      index++;
  }

  public int hashCode ()
  {
    return index + 3*point + 11*offset;
  }
}
