/* 
 * Copyright (c) 2000 ISP RAS.
 * B.Communisticheskaya,25, Moscow, Russia.
 * All rights reserved.
 *
 */

package jatva.iterators.lang;

public class NeighbourhoodIntegerIterator
  extends    AbstractIntegerIterator
  implements IIntegerIterator
{
  protected int point = 0;
  protected int offset = 0;
  protected int index  = 0;
  
  public NeighbourhoodIntegerIterator(int point, int offset)
  {
    if(offset < 0) offset = 0;
    if(offset > Integer.MAX_VALUE/2) offset = Integer.MAX_VALUE/2;
     
    this.point  = point;
    this.offset = offset;
  }

  public NeighbourhoodIntegerIterator(int point)
  {
    this(point, 0);
  }
  
  public NeighbourhoodIntegerIterator(NeighbourhoodIntegerIterator r)
  {
    this.point  = r.point;
    this.offset = r.offset;
    this.index  = r.index;
  }

  public Object clone()
  {
    return new NeighbourhoodIntegerIterator(this);
  }
  
  public boolean equals(Object o)
  {
    if(!(o instanceof NeighbourhoodIntegerIterator))
      return false;

    NeighbourhoodIntegerIterator obj = (NeighbourhoodIntegerIterator)o;

    return    index  == obj.index 
           && point  == obj.point
           && offset == obj.offset;
  }
  
  public int value()
  {
    return (int)(point + ((index%2 == 0)?(index/2):(-(index/2+1))));
  }
  
  public boolean stop()
  {
    return index > 2*offset;
  }
  
  public void shift()
  {
    index++;
    
    if(index == Integer.MAX_VALUE) return;
    if(      index%2 == 0
           && point > Integer.MAX_VALUE - index/2
        ||    index%2 == 1
           && point < Integer.MIN_VALUE + (index+1)/2
      )
      index++;
  }

  public int hashCode ()
  {
    return index + 3*point + 11*offset;
  }
}
