/* 
 * Copyright (c) 2000 ISP RAS.
 * B.Communisticheskaya,25, Moscow, Russia.
 * All rights reserved.
 *
 */

package jatva.iterators.lang;

public class NeighbourhoodShortIterator
  extends    AbstractShortIterator
  implements IShortIterator
{
  protected short point = 0;
  protected int offset = 0;
  protected int index  = 0;
  
  public NeighbourhoodShortIterator(short point, int offset)
  {
    int m = Math.max(Short.MAX_VALUE - point, point - Short.MIN_VALUE);
    if(offset > m) offset = m;
    if(offset < 0) offset = 0;
     
    this.point  = point;
    this.offset = offset;
  }

  public NeighbourhoodShortIterator(short point)
  {
    this(point, 0);
  }
  
  public NeighbourhoodShortIterator(NeighbourhoodShortIterator r)
  {
    this.point  = r.point;
    this.offset = r.offset;
    this.index  = r.index;
  }

  public Object clone()
  {
    return new NeighbourhoodShortIterator(this);
  }
  
  public boolean equals(Object o)
  {
    if(!(o instanceof NeighbourhoodShortIterator))
      return false;

    NeighbourhoodShortIterator obj = (NeighbourhoodShortIterator)o;

    return    index  == obj.index 
           && point  == obj.point
           && offset == obj.offset;
  }
  
  public short value()
  {
    return (short)(point + ((index%2 == 0)?(index/2):(-(index+1)/2)));
  }
  
  public boolean stop()
  {
    return index > 2*offset;
  }
  
  public void shift()
  {
    index++;
    
    if(      index%2 == 0
          && point > Short.MAX_VALUE - index/2
       ||    index%2 == 1
          && point < Short.MIN_VALUE + (index+1)/2
      )
      index++;
  }

  public int hashCode ()
  {
    return index + 3*point + 11*offset;
  }
}
