/* 
 * Copyright (c) 2000 ISP RAS.
 * B.Communisticheskaya,25, Moscow, Russia.
 * All rights reserved.
 *
 */

package jatva.iterators.lang;

public class ObjectIterator
  extends    AbstractObjectIterator
  implements IObjectIterator
{
  public static Object[] defaultValues = {
     null
   , new Object()
   , new Character((char)(0xffff))
   , new Integer(Integer.MIN_VALUE - 1)
   , null
   , new Character((char)(0xffff))
   , null
   , "72jFb#8a{u W>j=\'"
   , new java.util.Vector(18, 15)
   , null
  };
  static
  {
    defaultValues[4] = defaultValues[2];
    
    try
    {
     defaultValues[6] = Class.forName("java.lang.Object");
    }
    catch(ClassNotFoundException ex)
    {
      ex.printStackTrace();
    }
  }
  
  protected Object[] values = defaultValues;
  protected int index = 0;
  
  public ObjectIterator()
  {
  }
  
  public ObjectIterator(Object[] values)
  {
    if(values == null) throw new IllegalArgumentException("Argument should not be null");
    this.values = values;
  }
  
  public ObjectIterator(ObjectIterator right)
  {
    index = right.index;
    values = right.values;
  }
  
  public void addObject(Object n)
  {
    Object[] newValues = new Object[values.length+1];
    System.arraycopy(values, 0, newValues, 0, values.length);
    newValues[values.length] = n;
    values = newValues;
  }

  public synchronized Object clone()
  {
    return new ObjectIterator(this);
  }
  
  public synchronized void shift()
  {
    index++;
  }
  
  public Object value()
  {
    return values[index];
  }
  
  public boolean stop()
  {
    return index >= values.length;
  }

  public boolean equals(Object o) 
  {
    if(!(o instanceof ObjectIterator))
      return false;

    ObjectIterator obj = (ObjectIterator)o;

    if(index != obj.index) return false;
    if(values.length != obj.values.length) return false;
    
    for(int i = 0; i < values.length; i++)
      if(   values[i] == null && obj.values[i] != null
         || values[i] != null && !values[i].equals(obj.values[i])
        ) return false;
    
    return true;   
  }

  public int hashCode ()
  {
    int r = index;
    for(int i = 0; i < values.length; i++)
      r += values[i].hashCode()*i;
        
    return r;
  }
}
