/*
 * Copyright (c) 2004 ISP RAS.
 * 109004, B. Communisticheskaya, 25, Moscow, Russia.
 * All rights reserved.
 *
 * $Id: ConflictingMediatorObjectsException.java,v 1.1 2006/07/26 12:48:32 kuliamin Exp $
 * Created on 26.07.2006
 *
 */
package jatva.lang;

import jatva.util.Utils;

/** 
 *
 * @author Victor Kuliamin
 *
 */
public class ConflictingMediatorObjectsException
  extends CriticalRuntimeTestException
{

  /**
   * @param info
   * @param tags
   * @param values
   */
  public ConflictingMediatorObjectsException (ModelObject m1, ModelObject m2, Object[] impls)
  {
    super(  "Two mediator objects conflicting by their implementation fields found"
          , new String[]{ "object 1", "object 2", "implementation fields"}
          , new String[]{ Utils.getSimpleString(m1), Utils.getSimpleString(m2), Utils.getArraySimpleString(impls)}
         );
  }
  
  /**
   * @param info
   * @param error
   * @param tags
   * @param values
   */
  public ConflictingMediatorObjectsException (ModelObject m, String mclass, Object[] impls)
  {
    super(   "Mediator object found that prevents creation of new mediator object due to conflict by implementation fields"
           , new String[]{ "object", "current class", "implementation fields"}
           , new String[]{ Utils.getSimpleString(m), mclass, Utils.getArraySimpleString(impls)}
          );
  }

}
