/*
 * Copyright (c) 2004 ISP RAS.
 * B.Communisticheskaya,25, Moscow, Russia.
 * All rights reserved.
 *
 * HexUtilities
 * $Id: HexUtilities.java,v 1.2 2005/05/19 15:20:20 kuliamin Exp $
 *
 * Author: Alexei Barantsev <barancev@ispras.ru>
 * Created on April 26, 2004
 */
//=============================================================================

package jatva.lang;

//=============================================================================

//=============================================================================

final class HexUtilities {

    private static char[] hexChars =
        { '0', '1', '2', '3', '4', '5', '6', '7',
          '8', '9', 'A', 'B', 'C', 'D', 'E', 'F' };
    
    /*
     * Converts a byte to hex digit and writes to the supplied buffer
     */
    private static void byte2hex(byte b, StringBuffer buf) {
        int high = ((b & 0xf0) >> 4);
        int low = (b & 0x0f);
        buf.append(hexChars[high]);
        buf.append(hexChars[low]);
    }
    
    /*
     * Converts a byte array to hex string
     */
    static String toHexString(byte[] block) {
        StringBuffer buf = new StringBuffer();
    
        int len = block.length;
    
        for (int i = 0; i < len; i++) {
             byte2hex(block[i], buf);
        } 
    
        return buf.toString();
    }

}

//=============================================================================
//End of HexUtilities.java