/* 
 * Copyright (c) 2000 ISP RAS.
 * B.Communisticheskaya,25, Moscow, Russia.
 * All rights reserved.
 *
 */

package jatva.lang;

public class IllegalImplementationResultException 
  extends SpecificationViolationException
{
  public IllegalImplementationResultException(String p_class, String p_method, String info)
  {
	  super("Illegal result of implementation operation: " + info, new String[]{"class", "method"}, new String[]{p_class, p_method});
  }

  public IllegalImplementationResultException(String p_class, String p_method, Object obj)
  {
    super("Illegal result of implementation operation", new String[]{"class", "method", "result"}, new String[]{p_class, p_method, "" + obj});
  }

  public IllegalImplementationResultException(String p_class, String p_method, Object obj, String info)
  {
    super("Illegal result of implementation operation: " + info, new String[]{"class", "method", "result"}, new String[]{p_class, p_method, "" + obj});
  }

  public IllegalImplementationResultException(String p_class, String p_method, String info, Throwable error)
  {
    super("Illegal result of implementation operation: " + info, error, new String[]{"class", "method"}, new String[]{p_class, p_method});
  }
}
