/*
 * Copyright (c) 2004 ISP RAS.
 * 109004, B. Communisticheskaya, 25, Moscow, Russia.
 * All rights reserved.
 *
 * $Id: IncorrectMediatorObjectException.java,v 1.2 2005/09/20 09:37:44 kuliamin Exp $
 * Created on 02.08.2005
 *
 */
package jatva.lang;

import jatva.util.Utils;

public class IncorrectMediatorObjectException
  extends CriticalRuntimeTestException
{
  public IncorrectMediatorObjectException (String p_class, ModelObject obj, String[] names, Object[] fields)
  {
    super(  "Incorrect mediator object found for the implementation references"
          , prepareTags(names)
          , prepareValues(p_class, obj, fields)
         );
  }
  
  private static String[] prepareTags(String[] names)
  {
    String[] res = new String[names.length + 2];
    res[0] = "mediator class";
    res[1] = "object found";
    
    for(int i = 0; i < names.length; i++)
      res[i + 2] = names[i];
    
    return res;
  }
  
  private static String[] prepareValues(String p_class, ModelObject o, Object[] fields)
  {
    String[] res = new String[fields.length + 2];
    res[0] = p_class;
    res[1] = Utils.getSimpleString(o);
    
    for(int i = 0; i < fields.length; i++)
      res[i + 2] = Utils.getSimpleString(fields[i]);
    
    return res;
  }
}
