/*
 * Copyright (c) 2000 ISP RAS. 109004, B. Communisticheskaya, 25, Moscow,
 * Russia. All rights reserved.
 *
 * $Id: InvariantException.java,v 1.6 2008/08/07 19:19:44 almo Exp $ Created
 * on 01.04.2000
 */

package jatva.lang;

import jatva.util.Utils;

public class InvariantException extends StateSynchronizationException
{
    private static final String violationInfo = "Invariant violation";
    private static final String exceptionInfo = "Exception in invariant";

    public InvariantException( String p_class, String invariant )
    {
        super( violationInfo
             , new String[]{ "class", "invariant" }
             , new String[]{ p_class, invariant }
             );
    }

    public InvariantException( String p_class, String invariant, String comment )
    {
        super( Utils.appendCommentToFailure( violationInfo, comment )
             , new String[]{ "class", "invariant" }
             , new String[]{ p_class, invariant }
             );
    }

    public InvariantException( ModelObject object, String invariant )
    {
        super( violationInfo
             , new String[]{ "object", "invariant" }
             , new String[]{ Utils.getSimpleString( object ), invariant }
             );
    }

    public InvariantException( ModelObject object, String invariant, String comment )
    {
        super( Utils.appendCommentToFailure( violationInfo, comment )
             , new String[]{ "object", "invariant" }
             , new String[]{ Utils.getSimpleString( object ), invariant }
             );
    }

    public InvariantException( String p_class, String invariant, Throwable error )
    {
        super( exceptionInfo
             , error
             , new String[]{ "class", "invariant" }
             , new String[]{ p_class, invariant }
             );
    }

    public InvariantException( ModelObject object, String invariant, Throwable error )
    {
        super( exceptionInfo
             , error
             , new String[]{ "object", "invariant" }
             , new String[]{ Utils.getSimpleString( object ), invariant }
             );
    }
}
