package jatva.lang;

import jatva.lang.synchronization.SynchronizationObjectInterface;

public class ModelEventProperties
{
    private SynchronizationObjectInterface synchronizationObject;
    private Object channelID;
    
    public static final 
        ModelEventProperties Empty = new ModelEventProperties( null, null );

    /**
     * will be used to set the current channel id to the current registrar
     * see TestManager.registerModelEvent 
     */
    public static final Object defaultChannelId = new Object();

    public ModelEventProperties
        ( SynchronizationObjectInterface synchronizationObject )
    { this( synchronizationObject, null ); }

    public ModelEventProperties
        ( SynchronizationObjectInterface synchronizationObject
        , Object channelID 
        )
    {
        this.synchronizationObject = synchronizationObject;
        this.channelID = channelID;
    }

    public SynchronizationObjectInterface getSynchronizationObject()
    {
        return synchronizationObject;
    }

    public Object getChannelID()
    {
        return channelID;
    } 
}
