/*
 * Copyright (c) 2004 ISP RAS. 109004, B. Communisticheskaya, 25, Moscow,
 * Russia. All rights reserved.
 *
 * $Id: PostconditionViolationException.java,v 1.4 2005/09/20 09:37:44 kuliamin
 * Exp $ Created on 19.05.2005
 */
package jatva.lang;

import jatva.util.Utils;

/**
 *
 * @author Victor Kuliamin
 *
 */
public class PostconditionViolationException extends SpecificationViolationException
{
    private static final String info = "Postcondition violation";

    public PostconditionViolationException( String p_class, String p_method )
    {
        super( info
             , new String[]{ "class", "method" }
             , new String[]{ p_class, p_method }
             );
    }

    public PostconditionViolationException( String p_class, String p_method, String comment )
    {
        super( Utils.appendCommentToFailure( info, comment )
             , new String[]{ "class", "method" }
             , new String[]{ p_class, p_method }
             );
    }

    public PostconditionViolationException( ModelObject object, String p_method )
    {
        super( info
             , new String[]{ "object", "method" }
             , new String[]{ Utils.getSimpleString( object ), p_method }
             );
    }

    public PostconditionViolationException( ModelObject object, String p_method, String comment )
    {
        super( Utils.appendCommentToFailure( info, comment )
             , new String[]{ "object", "method" }
             , new String[]{ Utils.getSimpleString( object ), p_method }
             );
    }
}
