/*
 * Copyright (c) 2000 ISP RAS. 109004, B. Communisticheskaya, 25, Moscow,
 * Russia. All rights reserved.
 *
 * $Id: PreconditionViolationException.java,v 1.3 2005/09/20 09:37:44 kuliamin
 * Exp $ Created on 01.04.2000
 */

package jatva.lang;

import jatva.util.Utils;

public class PreconditionViolationException extends RuntimeTestException
{
    private static final String info = "Precondition violation";

    public PreconditionViolationException( String p_class, String p_method )
    {
        super( info
             , new String[]{ "class", "method" }
             , new String[]{ p_class, p_method }
             );
    }

    public PreconditionViolationException( String p_class, String p_method, String comment )
    {
        super( Utils.appendCommentToFailure( info, comment )
             , new String[]{ "class", "method", "comment" }
             , new String[]{ p_class, p_method, comment }
             );
    }

    public PreconditionViolationException( ModelObject object, String p_method )
    {
        super( info
             , new String[]{ "object", "method" }
             , new String[]{ Utils.getSimpleString( object ), p_method }
             );
    }

    public PreconditionViolationException( ModelObject object, String p_method, String comment )
    {
        super( Utils.appendCommentToFailure( info, comment )
             , new String[]{ "object", "method", "comment" }
             , new String[]{ Utils.getSimpleString( object ), p_method, comment }
             );
    }

}
