/*
 * Copyright (c) 2004 ISP RAS.
 * 109004, B. Communisticheskaya, 25, Moscow, Russia.
 * All rights reserved.
 *
 * $Id: ResultTracingException.java,v 1.3 2008/07/25 09:55:35 almo Exp $
 * Created on 04.08.2005
 *
 */
package jatva.lang;

import jatva.util.OperationInfo;
import jatva.util.Utils;

public class ResultTracingException
  extends RuntimeTestException
{
  public ResultTracingException ( OperationInfo op_info, Object result, Throwable error)
  {
    super(   "Exception occurred while trying to trace the implementation results", error
           , new String[]{"implementation class", "implementation method", "result"}
           , new String[]{ op_info.getDeclaringClass(), op_info.getPrettySignature(), Utils.getSimpleString(result)}
         );
  }

  public ResultTracingException ( OperationInfo op_info, Object object, Object result, Throwable error)
  {
    super(   "Exception occurred while trying to trace the implementation results", error
           , new String[]{"implementation object", "implementation method", "result"}
           , new String[]{Utils.getSimpleString(object), op_info.getPrettySignature(), Utils.getSimpleString(result)}
         );
  }

  public ResultTracingException ( OperationInfo op_info, Throwable exception, Throwable error)
  {
    super(   "Exception occurred while trying to trace the implementation exception", error
           , new String[]{"implementation class", "implementation method", "exception"}
           , new String[]{op_info.getDeclaringClass(), op_info.getPrettySignature(), Utils.getSimpleString(exception)}
         );
  }

  public ResultTracingException (OperationInfo op_info, Object object, Throwable exception, Throwable error)
  {
    super(   "Exception occurred while trying to trace the implementation exception", error
           , new String[]{"implementation object", "implementation method", "exception"}
           , new String[]{Utils.getSimpleString(object), op_info.getPrettySignature(), Utils.getSimpleString(exception)}
         );
  }
}
