/*
 * Copyright (c) 2004 ISP RAS.
 * 109004, B. Communisticheskaya, 25, Moscow, Russia.
 * All rights reserved.
 *
 * $Id: RuntimeMediatorMethodException.java,v 1.5 2006/04/07 10:38:08 kuliamin Exp $
 * Created on 19.05.2005
 *
 */
package jatva.lang;

import jatva.util.Utils;

/** 
 *
 * @author Victor Kuliamin
 *
 */
public class RuntimeMediatorMethodException
  extends RuntimeTestException
{
  public RuntimeMediatorMethodException(String p_class, String p_method, String info)
  {
    super(info, new String[]{"class", "method"}, new String[]{p_class, p_method});
  }
  
  public RuntimeMediatorMethodException(String p_class, String p_method, Throwable error)//, boolean isRegistered)
  {
    super(   //isRegistered?"Implementation exception is not correctly processed in mediator":"Exception in mediator method"
             "Exception in mediator method"
           , error, new String[]{"class", "method"}, new String[]{p_class, p_method}
    );
  }

  public RuntimeMediatorMethodException(ModelObject object, String p_method, Throwable error)//, boolean isRegistered)
  {
    super(  //isRegistered?"Implementation exception is not correctly processed in mediator":"Exception in mediator method"
            "Exception in mediator method"
          , error, new String[]{"object", "method"}, new String[]{Utils.getSimpleString(object), p_method}
    );
  }
}
