/*
 * Copyright (c) 2004 ISP RAS. 109004, B. Communisticheskaya, 25, Moscow,
 * Russia. All rights reserved.
 *
 * $Id: ScenarioConstraintViolationException.java,v 1.4 2005/07/07 05:20:50
 * kuliamin Exp $ Created on 19.05.2005
 */
package jatva.lang;

import jatva.util.Utils;

/**
 *
 * @author Victor Kuliamin
 *
 */
public class ScenarioConstraintViolationException extends SpecificationViolationException
{
    private static final String info = "Scenario method constraint failed";

    public ScenarioConstraintViolationException( String p_class, String p_method )
    {
        super( info
             , new String[]{ "class", "method" }
             , new String[]{ p_class, p_method }
             );
    }

    public ScenarioConstraintViolationException( String p_class, String p_method, String comment )
    {
        super( Utils.appendCommentToFailure( info, comment )
             , new String[]{ "class", "method" }
             , new String[]{ p_class, p_method }
             );
    }

    // public ScenarioConstraintViolationException(String p_class, String
    // p_method, String msg)
    // {
    // super("Scenario method constraint failed" + ((msg == null)?"":(": " +
    // msg)), new String[]{"class", "method"}, new String[]{p_class, p_method});
    // }

    public ScenarioConstraintViolationException( String p_class
                                               , String p_method
                                               , String msg
                                               , Throwable error
                                               )
    {
        super( Utils.appendCommentToFailure( info, "due to exception" + ( ( msg == null ) ? "" : ( ": " + msg ) ) )
             , error
             , new String[]{ "class", "method" }
             , new String[]{ p_class, p_method }
             );
    }
}
