/*
 * Copyright (c) 2004 ISP RAS.
 * 109004, B. Communisticheskaya, 25, Moscow, Russia.
 * All rights reserved.
 *
 * $Id: StateSynchronizationMethodException.java,v 1.2 2005/09/20 09:37:44 kuliamin Exp $
 * Created on 03.08.2005
 *
 */
package jatva.lang;

import jatva.util.Utils;

public class StateSynchronizationMethodException
    extends StateSynchronizationException
{
  public StateSynchronizationMethodException (String p_class, String method, Throwable error)
  {
    super("Exception in state synchronization method", error, new String[]{"class", "method"}, new String[]{p_class, method});
  }
  
  public StateSynchronizationMethodException (ModelObject object, String method, Throwable error)
  {
    super("Exception in state synchronization method", error, new String[]{"object", "method"}, new String[]{Utils.getSimpleString(object), method});
  }
  
  public StateSynchronizationMethodException (String p_class, String method, Throwable error, boolean flag)
  {
    super("Exception in state synchronization block", error, new String[]{"class", "block"}, new String[]{p_class, method});
  }

  public StateSynchronizationMethodException (ModelObject object, String method, Throwable error, boolean flag)
  {
    super("Exception in state synchronization block", error, new String[]{"object", "block"}, new String[]{Utils.getSimpleString(object), method});
  }
}
