/*
 * Created on 11.02.2005
 *
 */
package jatva.lang.synchronization;

import jatva.lang.ModelEvent;

/**
 * @author Victor Kuliamin
 *
 */
public class EventList
{
  public EventList() {}
  
  public ModelEvent get(int i)
  {
    if(i >= 0 && i < size) return items[i];
    else                   return null;
  }
  
  public void add(int i, ModelEvent e)
  {
    if(i >= 0 && i <= size)
    {
      if(items.length > size)
      {
        if(i < size) System.arraycopy(items, i, items, i+1, size-i);
        items[i] = e;
      }
      else
      {
        ModelEvent[] newItems = new ModelEvent[size + extent];
        if(i > 0)    System.arraycopy(items, 0, newItems, 0, i);
        if(i < size) System.arraycopy(items, i, newItems, i+1, size-i);
        newItems[i] = e;
        items = newItems;
      }
      size++;
    }
  }
  
  public void addLast(ModelEvent e)
  {
    if(items.length > size) items[size] = e;
    else
    {
      ModelEvent[] newItems = new ModelEvent[size + extent];
      System.arraycopy(items, 0, newItems, 0, size);
      newItems[size] = e;
      items = newItems;
    }
    size++;
  }
  
  public ModelEvent remove(int i)
  {
    if(i >= 0 && i < size)
    {
      ModelEvent res = items[i];
      if(i < size - 1) System.arraycopy(items, i+1, items, i, size-i-1);
      size--;
      return res;
    }
    else return null;
  }
  
  public ModelEvent removeLast()
  {
    ModelEvent res = items[size-1];
    size--;
    return res;
  }
  
  public ModelEvent set(int i, ModelEvent e)
  {
    if(i >= 0 && i < size)
    {
      ModelEvent res = items[i];
      items[i] = e;
      return res;
    }
    else return null;
  }
  
  public int size()
  {
    return size;
  }
  
  public void clear()
  {
    size = 0;
  }
  
  public EventList(EventList r)
  {
    size = r.size;
    items = new ModelEvent[r.items.length];
    System.arraycopy(r.items, 0, items, 0, size);
  }
  
  public String toString()
  {
    StringBuffer r = new StringBuffer("" + size + "[");
    for(int i = 0; i < size; i++)
    {
      if(i != 0) r.append(", ");
      r.append(items[i].toString());
    }
    
    r.append("]");
    return r.toString();
  }
  
  public Object clone()
  {
    return new EventList(this);
  }
  
  private static final int startingSize = 5;
  private static final int extent       = 5;
  
  private ModelEvent[] items = new ModelEvent[startingSize];
  private int          size  = 0;
  /*
  public static void main(String[] args)
  {
    EventList l = new EventList();
    
    System.out.println("start : " + l);
    
    l.addLast(new ModelEvent("a"));
    l.addLast(new ModelEvent("b"));
    
    System.out.println("fisrt : " + l);
    
    for(int i = 0; i < 50; i++)
    {
      l.add((i%2 == 0)?i+1:2, new ModelEvent((i%2 == 0)?"c":"d"));
      
      System.out.println("addcl : " + l);
    }
    
    for(int i = 0; i < 45; i++)
    {
      l.remove((i%3 == 0)?0:((i%3 == 1)?i-1:2));
      
      System.out.println("remcl : " + l);
    }
  }*/
}
