/* 
 * Copyright (c) 2000 ISP RAS.
 * B.Communisticheskaya,25, Moscow, Russia.
 * All rights reserved.
 *
 */

package jatva.lang.synchronization;

import jatva.iterators.lang.IObjectIterator;
import jatva.lang.MediatorInterface;
import jatva.lang.ModelObject;
import jatva.util.IdentityList;
import jatva.util.Utils;
import jatva.util.WeakIdentitySet;

public class SynchronizationManager
{
  //private static SynchronizationManager _manager = new SynchronizationManager();
  public static SynchronizationManager getManager()
  {
    return TestManager.getRegistrar().getTest().getSynchronizationManager();
  }
  
  private WeakIdentitySet _mediators = new WeakIdentitySet();
  private WeakIdentitySet _inverse   = new WeakIdentitySet();
  private WeakIdentitySet _models    = new WeakIdentitySet();
                                        
  public SynchronizationManager()
  {
  }
  
  public static void register(ModelObject o)
  {
    SynchronizationManager m = getManager();
    m._models.add(o);
    if(o instanceof MediatorInterface) m._mediators.add(o);
  }

  public static void unregister(ModelObject o)
  {
    SynchronizationManager m = getManager();
    m._models.remove(o);
    if(o instanceof MediatorInterface) m._mediators.remove(o);
  }
  
  public static void registerInverse(Object o)
  {
    SynchronizationManager m = getManager();
    m._inverse.add(o);
  }
  
  public static void unregisterInverse(Object o)
  {
    SynchronizationManager m = getManager();
    m._inverse.remove(o);
  }

  
  public static int getUpdateNumber()
  {
    return getManager()._updateNumber;
  }
  
  protected int _updateNumber = 0;

  //protected Vector/*MediatorInterface*/   _primeMediators = new Vector();
  //protected static Hashtable              _threads = new Hashtable();
  /*
  public static void registerAsPrime(MediatorInterface med)
  {
    SynchronizationManager manager = getManager();
    Vector mediators = manager._primeMediators;
    
    if(!mediators.contains(med))
      mediators.addElement(med);
  }*/

  private IdentityList/*Cleanable*/ _objectsToClean = new IdentityList();
  
  public static void registerForCleaning(ModelObject obj)
  {
    SynchronizationManager m = getManager();
    m._objectsToClean.addLast(obj);
  }
  /*
  public synchronized static void updatePrimes()
    throws StateSynchronizationException
  {
    SynchronizationManager manager = getManager();
    Vector mediators = manager._primeMediators;
    
    for(int i = 0; i < mediators.size(); i++)
      ((MediatorInterface)mediators.elementAt(i)).mapStateUp();
  }*/
  
  public static void updateInverse()
  {
    
  }
  
  public void update()
  {
    //SynchronizationManager manager = getManager();
    //WeakIdentitySet mediators = manager._mediators;
    //WeakIdentitySet models    = manager._models;
    //WeakIdentitySet objectsToClean = manager._objectsToClean;
    //manager._updateNumber++;
    
    
    //for(int i = 0; i < objectsToClean.size(); i++)
    //  ((Cleanable)objectsToClean.elementAt(i)).cleanUpModel();
      
    //objectsToClean.clear();
    //for(IObjectIterator i = manager._mediators.iterator(); !i.stop(); i.shift())
    //  ((ModelObject)i.value())._ts_mapStateUp();
    
    //for(int i = 0; i < mediators.size(); i++)
    //  ((MediatorInterface)mediators.elementAt(i)).mapStateUp();
    
    //for(int i = 0; i < objectsToClean.size(); i++)
    //  ((Cleanable)objectsToClean.elementAt(i)).cleanUpModel();
      
    //objectsToClean.clear();

    //for(int i = 0; i < mediators.size(); i++)
    //  ((MediatorInterface)mediators.elementAt(i))._ts_checkInvariants();
    
    //jatva.lang.synchronization.TestManager.getRegistrar().traceMessage("    UPDATE IN SYNCHMANAGER");
    //jatva.lang.synchronization.TestManager.getRegistrar().traceMessage("    MEDIATORS : " + _mediators.size());
    //jatva.lang.synchronization.TestManager.getRegistrar().traceMessage("    MODELS : " + _models.size());
    
    _updateNumber++;
    
    for(IObjectIterator i = _mediators.iterator(); !i.stop(); i.shift())
    {
      //jatva.lang.synchronization.TestManager.getRegistrar().traceMessage("    UPDATING OBJECT " + Utils.getSimpleString(i.value()));
      ((ModelObject)i.value())._ts_mapStateUp();
    }
  }
  
  public void check()
  {
    //SynchronizationManager manager = getManager();
    
    for(IObjectIterator i = _models.iterator(); !i.stop(); i.shift())
    {
      ((ModelObject)i.value())._ts_checkAllInvariants();
    }
  }
  
  public void checkPrime()
  {
    //SynchronizationManager manager = getManager();

    for(IObjectIterator i = _models.iterator(); !i.stop(); i.shift())
      ((ModelObject)i.value())._ts_checkPrimeInvariants();
  }
}