package jatva.lang.synchronization;

import java.lang.annotation.Documented;
import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

/**
 * This annotation can be applied either to specification method or to scenario method.
 * If the method has Unmixable annotation and it overrides some method from super-class, then
 * those super-class method should have Unmixable annotation too.
 * @author almo
 */
@Documented
@Retention(RetentionPolicy.RUNTIME)
@Target( { ElementType.METHOD, ElementType.TYPE } )
public @interface Unmixable
{}
