/*
 * Copyright (c) 2000-2003 ISP RAS.
 * B.Communisticheskaya,25, Moscow, Russia.
 * All rights reserved.
 *
 * TracerInternalError
 * $Id: TracerInternalError.java,v 1.3 2006/05/16 09:56:52 kuliamin Exp $
 *
 * Author: Victor Kuliamin <kuliamin@ispras.ru>
 * Created on December 6, 2002
 */
//=============================================================================

package jatva.tracer;

//=============================================================================

import jatva.lang.TestSystemInternalError;

//=============================================================================

/**
 * Thrown when an internal error occured in tracer subsystem.
 *
 * @author <a href="mailto:barancev@ispras.ru">Alexei Barantsev</a>
 */
public class TracerInternalError
  extends TestSystemInternalError 
{
  public TracerInternalError(String info, Throwable error) 
  {
    super(info, error, true, false, null, null);

    System.err.println("Internal error in tracing mechanism");
    System.err.println(info);
    System.err.println("Cause :");
    error.printStackTrace(System.err);
  }

  public TracerInternalError(String info) 
  {
    super(info, null, true, false, null, null);
    
    System.err.println("Internal error in tracing mechanism");
    System.err.println(info);
  }
}
//=============================================================================
// End of TracerInternalError.java
