/*
 * Copyright (c) 2003 ISP RAS.
 * B.Communisticheskaya,25, Moscow, Russia.
 * All rights reserved.
 *
 * ValueKind
 * $Id: ValueKind.java,v 1.3 2007/10/08 15:09:56 almo Exp $
 *
 * Author: Alexei Barantsev <barancev@ispras.ru>
 * Created on 28.08.2003
 */
//=============================================================================

package jatva.tracer;

//=============================================================================

//=============================================================================

/**
 * Value kind enumeration.
 * 
 * @author <a href="mailto:barancev@ispras.ru">Alexei Barantsev</a>
 */
public final class ValueKind {

    private String name;

    private ValueKind(String name) {
        this.name = name;
    }

    public static ValueKind GENSTATE
        = new ValueKind("state");
    public static ValueKind SCENARIO_METHOD
        = new ValueKind("scenario method");
    public static ValueKind ITERATION_VARIABLE
        = new ValueKind("iteration variable");
    public static ValueKind COLLECTION_ITERATION_VARIABLE
        // = new ValueKind("collection iteration variable");
        = new ValueKind("iteration variable");
    public static ValueKind CHOICE_ITERATION_VARIABLE
        // = new ValueKind("choice iteration variable");
        = new ValueKind("iteration variable");
    public static ValueKind COVERAGE_ITERATION_VARIABLE
        // = new ValueKind("coverage iteration variable");
        = new ValueKind("iteration variable");
    
    
    public static ValueKind ARGUMENT
        = new ValueKind("argument");
    public static ValueKind RESULT
        = new ValueKind("result");
    public static ValueKind EXCEPTION
        = new ValueKind("exception");

    public String toString() {
        return name;
    }

}

//=============================================================================
// End of ValueKind.java