/*
 * Copyright (c) 2000 ISP RAS.
 * B.Communisticheskaya,25, Moscow, Russia.
 * All rights reserved.
 *
 * WriteToConsole
 * $Id: WriteToConsole.java,v 1.3 2008/05/16 13:02:36 almo Exp $
 *
 * Author: Alexei Barantsev <barancev@ispras.ru>
 * Created on December 9, 2002
 */
//=============================================================================

package jatva.tracer.impl;


//=============================================================================

//=============================================================================

/** 
 * This class implements writing trace messages to console.
 *
 * @author  <a href="mailto:barancev@ispras.ru">Alexei Barantsev</a>
 * @version 1.0
 */
public class WriteToConsole
  extends AbstractWriter 
{
  /** 
   * Creates a new instance of WriteToConsole.
   */
  public WriteToConsole()
  {
  }

  /** 
   * Writes message to console.
   * 
   * @see AbstractWriter#sendMessage(String)
   */
  public void sendMessage(StringBuffer message)
  {
    synchronized (WriteToConsole.class)
    {
      System.out.print(message);
      System.out.flush();
    }
  }
}

//=============================================================================
// End of file WriteToConsole.java
