/*
 * Copyright (c) 2000 ISP RAS.
 * B.Communisticheskaya,25, Moscow, Russia.
 * All rights reserved.
 *
 * WriteToNull
 * $Id: WriteToNull.java,v 1.3 2008/05/16 13:02:36 almo Exp $
 *
 * Author: Alexei Barantsev <barancev@ispras.ru>
 * Created on March 26, 2003
 */
//=============================================================================

package jatva.tracer.impl;


//=============================================================================

//=============================================================================

/** 
 * This class implements writing trace messages to nowhere.
 *
 * @author  <a href="mailto:barancev@ispras.ru">Alexei Barantsev</a>
 * @version 1.0
 */
public class WriteToNull extends AbstractWriter {

    /** 
     * Creates a new instance of <code>WriteToNull</code>.
     */
    public WriteToNull() {
    }

    /** 
     * Ignores all messages.
     * 
     * @see AbstractWriter#sendMessage(String)
     */
    public void sendMessage(StringBuffer message) {
    }

    /** 
     * Does nothing.
     * 
     * @see AbstractWriter#finish()
     */
    public void finish() {
    }

}

//=============================================================================
// End of file WriteToNull
