package jatva.tracer.messages;

import jatva.lang.synchronization.TestManager;
import jatva.tracer.Tracer;

public abstract class TracerMessage
{
    protected Tracer tracer;
    protected TestManager registrar;

    /**
     * The string reppresentation of this message formed by
     * tracer's formatter.
     * If this field is null then this message was surpressed by the Tracer.
     */
    protected StringBuffer stringForm;

    public final TestManager getRegistrar()
    { return registrar; }

    public TracerMessage( TestManager registrar )
    { 
        this.registrar = registrar;
        this.tracer = registrar.getTracer();
    }

    public void makeStringForm()
    {
        this.stringForm = format();
    }

    protected abstract StringBuffer format();

    public final void trace()
    { tracer.traceMessage( this ); }

    public StringBuffer getStringForm()
    { return stringForm; }
}
