/*
 * Created on 24.05.2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package jatva.util;

import jatva.iterators.lang.AbstractObjectPairIterator;
import jatva.iterators.lang.IObjectPairIterator;

/**
 * @author Administrator
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public abstract class AbstractHashMap
  extends AbstractMap
  implements IMap
{
  abstract protected int       hashKey(Object o);
  abstract protected int       hashValue(Object o);
  abstract protected boolean   equalKeys(Object o1, Object o2);
  abstract protected boolean   equalValues(Object o1, Object o2);
  abstract protected IList     makeList();
  abstract protected ISet      makeSet();
  abstract protected IMultiSet makeMultiSet();

  abstract public Object clone();
  
  public AbstractHashMap() {}
  
  public AbstractHashMap(Object key, Object val)
  {
    _size = 1;
    MapNode p = new MapNode(key, val);
    _items[hashKey(key)&(_itemsNumber-1)] = p;
    p._bkw = p._frw = _last = p;   
  }
  
  public AbstractHashMap(IMap m)
  {
    super(m);
  }
  
  public AbstractHashMap(ISet s)
  {
    super(s);
  }

  public AbstractHashMap(ISet s, Object o)
  {
    super(s, o);
  }

  public void clear()
  {
    _items = new MapNode[_itemsNumber];
    _size  = 0;
    _last  = null;
  }
  
  public int size()
  {
    return _size;
  }

  public boolean contains(Object key, Object val)
  {
    int h = hashKey(key)&(_itemsNumber-1);
    MapNode p = _items[h];
    
    while(p != null)
    {
      if(equalKeys(p._key, key)) return equalValues(p._val, val);
      p = p._next;
    }
    
    return false;
  }
  
  public boolean containsKey(Object key)
  {
    int h = hashKey(key)&(_itemsNumber-1);
    MapNode p = _items[h];
    
    while(p != null)
    {
      if(equalKeys(p._key, key)) return true;
      p = p._next;
    }
    
    return false;
  }
  
  public Object get(Object key)
  {
    int h = hashKey(key)&(_itemsNumber-1);
    MapNode p = _items[h];
    
    while(p != null)
    {
      if(equalKeys(p._key, key)) return p._val;
      p = p._next;
    }
    
    return null;
  }
  
  public Object put(Object key, Object value)
  {
    int h = hashKey(key)&(_itemsNumber-1);
    MapNode p = _items[h];
    Object r = null;
    
    while(p != null)
    {
      if(equalKeys(p._key, key))
      {
        r = p._val;
        p._val = value;
        return r;
      } 
      p = p._next;
    }
    
    p = new MapNode(key, value);
    p._next = _items[h];
    _items[h] = p;
    if(_size++ == 0) { _last = p._bkw = p._frw = p; }
    else             { p._frw = _last._frw; p._bkw = _last; _last._frw = p; _last = p; }
    return null;
  }
  
  public boolean remove(Object key, Object val)
  {
    int h = hashKey(key)&(_itemsNumber-1);
    MapNode p = _items[h], q = null;
    
    while(p != null)
    {
      if(equalKeys(p._key, key))
      { 
        if(equalValues(p._val, val))
        {
          if(q == null) _items[h] = p._next;
          else          q._next   = p._next;
          
          if(_size-- == 1) _last = null;
          else
          {
            p._bkw._frw = p._frw;
            p._frw._bkw = p._bkw;
            if(p == _last) _last = p._bkw;
          }
          return true;
        }
        else return false;
      }
      q = p; 
      p = p._next;
    }
    
    return false;
  }

  public Object removeKey(Object key)
  {
    int h = hashKey(key)&(_itemsNumber-1);
    MapNode p = _items[h], q = null;
    
    while(p != null)
    {
      if(equalKeys(p._key, key))
      { 
        if(q == null) _items[h] = p._next;
        else          q._next   = p._next;
        
        if(_size-- == 1) _last = null;
        else
        {
          p._bkw._frw = p._frw;
          p._frw._bkw = p._bkw;
          if(p == _last) _last = p._bkw;
        }
        return p._val;
      }
      q = p; 
      p = p._next;
    }
    
    return null;
  }

  public boolean extend(IMap m)
  {
    boolean res = false;
    if(m != null && m.size() != 0)
      l:for(IObjectPairIterator i = m.iterator(); !i.stop(); i.shift())
      {
        int h = hashKey(i.value1())&(_itemsNumber-1);
        MapNode p = _items[h];
    
        while(p != null)
        {
          if(equalKeys(p._key, i.value1())) continue l;
          p = p._next;
        }
    
        p = new MapNode(i.value1(), i.value2());
        p._next = _items[h];
        _items[h] = p;
        if(_size++ == 0) { _last = p._bkw = p._frw = p; }
        else             { p._frw = _last._frw; p._bkw = _last; _last._frw = p; _last = p; }
        res = true;
      }
        
    return res;
  }

  public boolean replace(IMap m)
  {
    boolean res = false;
    if(m != null && m.size() != 0)
      l:for(IObjectPairIterator i = m.iterator(); !i.stop(); i.shift())
      {
        int h = hashKey(i.value1())&(_itemsNumber-1);
        MapNode p = _items[h];
    
        while(p != null)
        {
          if(equalKeys(p._key, i.value1()))
          {
            if(!equalValues(p._val, i.value2()))
            {
              res = true;
              p._val = i.value2(); 
            }
            continue l;
          } 
          p = p._next;
        }
      }
        
    return res;
  }

  public IObjectPairIterator iterator()
  {
    return new MapIterator(this);
  }

  protected static class MapIterator
    extends    AbstractObjectPairIterator
    implements IObjectPairIterator
  {
    private MapNode         p = null;
    private AbstractHashMap s = null; 
        
    MapIterator(AbstractHashMap s)  
    {
      this.s = s;
      if(s._last == null) p = null;
      else                p = s._last._frw;
    }
       
    MapIterator(MapIterator r)
    {
      s = r.s;
      p = r.p;
    }
    
    public boolean stop()
    {
      if(p == null) return true;
      else          return false;
    }
  
    public void shift()
    {
      if(p == s._last) p = null;
      else             p = p._frw;
    }
      
    public Object value1()
    {
      return p._key;
    }
  
    public Object value2()
    {
      return p._val;
    }

    public Object clone()
    {
      return new MapIterator(this);
    }
      
    public boolean equals(Object o)
    {
      if(!(o instanceof MapIterator)) return false;
      
      MapIterator r = (MapIterator)o;
       
      return r.s == s && r.p == p;
    }

    public int hashCode()
    {
      return s.hashCode() + 17*System.identityHashCode(p);
    }
    
    public void remove()
    {
      Object k = p._key;
      p = p._frw;
      if(p == s._last._frw) p = null;
      
      s.removeKey(k);
    }


    public void replaceObject1(Object o)
    {
      // TODO Auto-generated method stub
    }

    public void replaceObject2(Object o)
    {
      p._val = o;
    }
  }
  
  static int _itemsNumber = 16;
  
  MapNode _items[] = new MapNode[_itemsNumber];
  int     _size;//    = 0;
  MapNode _last;//    = null;
  
  protected static class MapNode
  {
    MapNode _bkw;
    MapNode _frw;
    MapNode _next;
    Object  _key;
    Object _val;
    
    MapNode(Object key, Object value) { _key = key; _val = value; }
  }
}
