/*
 * Created on 24.05.2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package jatva.util;

import jatva.iterators.lang.AbstractObjectPairIterator;
import jatva.iterators.lang.IObjectPairIterator;

/**
 * @author Administrator
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public abstract class AbstractTreeMap
  extends AbstractMap
  implements IMap
{
  abstract protected int       hashKey(Object o);
  abstract protected int       hashValue(Object o);
  abstract protected boolean   equalValues(Object o1, Object o2);
  abstract protected IList     makeList();
  abstract protected ISet      makeSet();
  abstract protected IMultiSet makeMultiSet();

  abstract public Object clone();

  public AbstractTreeMap() {}
  
  public AbstractTreeMap(Object key, Object val)
  {
    _size = 1;
    _head = new MapNode(key, val);
    _head._bkw = _head._frw = _last = _head;   
  }
  
  public AbstractTreeMap(IMap m)
  {
    super(m);
  }
  
  public AbstractTreeMap(ISet s)
  {
    super(s);
  }

  public AbstractTreeMap(ISet s, Object o)
  {
    super(s, o);
  }

  public void clear()
  {
    _head = null;
    _last = null;
    _size = 0;
  }
  
  public int size()
  {
    return _size;
  }
  
  public boolean containsKey(Object key)
  {
    if(_head == null) return false;
    
    MapNode p = _head;
    do
    {
      if(hashKey(p._key) == hashKey(key))     return true;
      else if(hashKey(p._key) > hashKey(key)) p = p._left;
      else                                    p = p._right;
    }
    while(p != null);
    
    return false;
  }
  
  public boolean contains(Object key, Object val)
  {
    if(_head == null) return false;
    
    MapNode p = _head;
    do
    {
      if(hashKey(p._key) == hashKey(key))     return equalValues(p._val, val); 
      else if(hashKey(p._key) > hashKey(key)) p = p._left;
      else                                    p = p._right;
    }
    while(p != null);
    
    return false;
  }
 
  public Object get(Object key)
  {
    if(_head == null) return null;
    
    MapNode p = _head;
    do
    {
      if(hashKey(p._key) == hashKey(key))     return p._val;
      else if(hashKey(p._key) > hashKey(key)) p = p._left;
      else                                    p = p._right;
    }
    while(p != null);
    
    return null;
  }
  
  public Object put(Object key, Object value)
  {
    if(_head == null)
    {
      _head = new MapNode(key, value);
      _head._red = false;
      _head._bkw = _head._frw = _last = _head;   
      _size++;
      
      return null;
    }
    
    MapNode p = _head, q;
    Object  v = null;
    do
    {
      q = p;
      if(hashKey(p._key) == hashKey(key))
      {
        v = p._val;
        p._val = value;
        return v; 
      } 
      else if(hashKey(p._key) > hashKey(key)) p = p._left;
      else                                    p = p._right;
    }
    while(p != null);
    
    if(hashKey(q._key) > hashKey(key)) q._left = ( p =  new MapNode(key, value) );
    else                               q._right = ( p = new MapNode(key, value) );
    p._parent = q;
    
    _size++;
    p._frw = _last._frw;
    p._bkw = _last;
    _last._frw = p;
    _last = p;
    
    MapNode r;
    while(q != null && q._red == true)
    {
      if(q == q._parent._left)
      {
        r = q._parent._right;
        if(r == null || !r._red )
        {
          if(p == q._right)
          {
            q._right = p._left;
            if(p._left != null) p._left._parent = q;
            p._left = q;
            p._parent = q._parent;
            q._parent._left = p;
            q._parent = p;
            p = q;
            q = q._parent;
          }
          if(q._parent._parent != null)
          {
            if(q._parent._parent._left == q._parent) q._parent._parent._left = q;
            else                                     q._parent._parent._right = q;
          }
          else _head = q;
          
          q._red = false;
          q._parent._red = true;
          q._parent._left = q._right;
          if(q._right != null) q._right._parent = q._parent;
          q._right = q._parent;
          q._parent = q._parent._parent;
          q._right._parent = q;
          
          return null;
        }
        else
        {
          q._red = false;
          r._red = false;
          q._parent._red = true;
          p = q._parent;
          q = p._parent;
        }
      }
      else
      {
        r = q._parent._left;
        if(r == null || !r._red)
        {
          if(p == q._left)
          {
            q._left = p._right;
            if(p._right != null) p._right._parent = q;
            p._right = q;
            p._parent = q._parent;
            q._parent._right = p;
            q._parent = p;
            p = q;
            q = q._parent;
          }
          if(q._parent._parent != null)
          {
            if(q._parent._parent._left == q._parent) q._parent._parent._left = q;
            else                                     q._parent._parent._right = q;
          }
          else _head = q;
          
          q._red = false;
          q._parent._red = true;
          q._parent._right = q._left;
          if(q._left != null) q._left._parent = q._parent;
          q._left = q._parent;
          q._parent = q._parent._parent;
          q._left._parent = q;
          
          return null;
        }
        else
        {
          q._red = false;
          r._red = false;
          q._parent._red = true;
          p = q._parent;
          q = p._parent;
        }
      }
    }
    
    _head._red = false;
    return null;
  }
  
  public Object removeKey(Object key)
  {
    if(_head == null) return null;
    
    MapNode p = _head;
    do
    {
      if(hashKey(p._key) > hashKey(key))      p = p._left;
      else if(hashKey(p._key) < hashKey(key)) p = p._right;
      else                          break;
    }
    while(p != null);
    
    if(p == null) return null;
    Object v = p._val;
    
    removeNode(p);
    return v;
  }

  public boolean remove(Object key, Object val)
  {
    if(_head == null) return false;
    
    MapNode p = _head;
    do
    {
      if(hashKey(p._key) > hashKey(key))      p = p._left;
      else if(hashKey(p._key) < hashKey(key)) p = p._right;
      else                          break;
    }
    while(p != null);
    
    if(p == null || !equalValues(p._val, val)) return false;
    
    removeNode(p);
    return true;
  }
  
  public IObjectPairIterator iterator()
  {
    return new MapIterator(this);
  }

  protected MapNode minNode()
  {
    if(_head == null) return null;
    else              return _head.min();
  }
  
  protected MapNode maxNode()
  {
    if(_head == null) return null;
    else              return _head.max();
  }
  
  protected MapNode nextNode(MapNode p)
  {
    if(p._right != null) return p._right.min();
    while(p._parent != null && p == p._parent._right) p = p._parent;
    return p._parent;
  }
  
  protected MapNode prevNode(MapNode p)
  {
    if(p._left != null) return p._left.max();
    while(p._parent != null && p == p._parent._left) p = p._parent;
    return p._parent;
  }

  protected void fixup(MapNode p, MapNode q, boolean isLeft)
  {
    while(p != null && ( q == null || q._red == false ) )
    {
      MapNode w, v;
      
      if(isLeft)
      {
        w = p._right;
        if(w._red)
        {
          w._red = false;
          p._red = true;
          rotate(true, p);
          w = p._right;
        }
        v = w._left;
        
        if(w._right == null || !w._right._red)
        {
          if(v == null || !v._red)
          {
            w._red = true;
            q = p;
            p = p._parent;
            isLeft = (p == null)?true:(q == p._left);
            continue;
          }
          else
          {
            w._red = true;
            v._red = false;
            rotate(false, w);
            w = v;
            v = v._left;
          }
        }
        
        w._red = p._red;
        p._red = false;
        if(w._right != null) w._right._red = false;
        rotate(true, p);
        
        q = _head;
        p = null;
      }
      else
      {
        w = p._left;
        if(w._red)
        {
          w._red = false;
          p._red = true;
          rotate(false, p);
          w = p._left;
        }
        v = w._right;
        
        if(w._left == null || !w._left._red)
        {
          if(v == null || !v._red)
          {
            w._red = true;
            q = p;
            p = p._parent;
            isLeft = (p == null)?true:(q == p._left);
            continue;
          }
          else
          {
            w._red = true;
            v._red = false;
            rotate(true, w);
            w = v;
            v = v._right;
          }
        }
        
        w._red = p._red;
        p._red = false;
        if(w._left != null) w._left._red = false;
        rotate(false, p);
        q = _head;
        p = null;
      }
    }
    
    if(q != null) q._red = false;
  }

  protected void rotate(boolean left, MapNode x)
  {
    MapNode y;
    if(left)
    {
      y = x._right;
      x._right = y._left;
      if(y._left != null) y._left._parent = x;
      
      y._parent = x._parent;
      if(x._parent != null)
      {
        if(x == x._parent._left) x._parent._left = y;
        else                     x._parent._right = y;
      }
      else _head = y;
      
      y._left = x;
      x._parent = y;
    }
    else
    {
      y = x._left;
      x._left = y._right;
      if(y._right != null) y._right._parent = x;
      
      y._parent = x._parent;
      if(x._parent != null)
      {
        if(x == x._parent._left) x._parent._left = y;
        else                     x._parent._right = y;
      }
      else _head = y;
      
      y._right = x;
      x._parent = y;
    }
  }
  
  protected void removeNode(MapNode p)
  {
    if(_size == 1)
    {
      _last = null;
      _head = null;
      _size--;
      
      return; 
    } 
    else
    { 
      p._bkw._frw = p._frw; 
      p._frw._bkw = p._bkw;
      if(p == _last) _last = p._bkw;
    }
    
    boolean isLeft;
    
    if(p._left == null)
    {
      if(p._parent == null) { _head = p._right; isLeft = true; }
      else
      {
        if(p == p._parent._left) { p._parent._left = p._right;  isLeft = true; }
        else                     { p._parent._right = p._right; isLeft = false; }
      }
      
      if(p._right != null) p._right._parent = p._parent;
      
      if(!p._red) fixup(p._parent, p._right, isLeft);
    }
    else if(p._right == null)
    {
      if(p._parent == null) { _head = p._left; isLeft = true; }
      else
      {
        if(p == p._parent._left) { p._parent._left = p._left;  isLeft = true; }
        else                     { p._parent._right = p._left; isLeft = false; }
      }
      
      p._left._parent = p._parent;
      if(!p._red) fixup(p._parent, p._left, isLeft);
    }
    else
    {
      MapNode q = nextNode(p);
      p._key = q._key;
      p._val = q._val;
      q._bkw._frw = p;
      q._frw._bkw = p;
      p._bkw = q._bkw;
      p._frw = q._frw;
      
      if(q._parent == null) { _head = q._right; isLeft = true; }
      else
      {
        if(q == q._parent._left) { q._parent._left = q._right;  isLeft = true; }
        else                     { q._parent._right = q._right; isLeft = false; }
      }
      
      if(q._right != null) q._right._parent = q._parent;
      
      if(!q._red) fixup(q._parent, q._right, isLeft); 
    }
    
    _size--;
    return;
  }

  MapNode _head;// = null;
  int     _size;// = 0;
  MapNode _last;// = null;
  
  protected static class MapNode
  {
    MapNode _bkw;
    MapNode _frw;
    MapNode _left;
    MapNode _right;
    MapNode _parent;
    Object  _key;
    Object  _val;
    boolean _red = true;
    
    MapNode(Object key, Object val) { _key = key; _val = val; }
    
    MapNode min()
    {
      MapNode p = this;
      while(p._left != null) p = p._left;
      return p;
    }
    
    MapNode max()
    {
      MapNode p = this;
      while(p._right != null) p = p._right;
      return p;
    }
    
    boolean isChild(MapNode p)
    {
      if(p == null) return false;
      if(p == this) return true;
      if(_left != null && _left.isChild(p))   return true;
      if(_right != null && _right.isChild(p)) return true;
      return false;
    }
    
    int fill(ObjectPair array[], int ind)
    {
      int res = ind+1;
      array[ind] = new ObjectPair(_key, _val);
    
      if(_left != null)
      {
        res = _left.fill(array, ind+1);
        if(_right != null) return _right.fill(array, res);
      }
      else if(_right != null) return _right.fill(array, ind+1);
      return res;
    }
  
    void appendStringBuffer(StringBuffer st)
    {
      st.append("" + _key + " : " + _val);
      st.append("( " + ((_frw == null)?_frw:_frw._key) + " | " + ((_bkw == null)?_bkw:_bkw._key) + " )");
    
      if(_left != null)
      {
        st.append(", ");
        _left.appendStringBuffer(st);
      
        if(_right != null)
        {
          st.append(", ");
          _right.appendStringBuffer(st);
        }
      }
      else if(_right != null)
      {
        st.append(", ");
        _right.appendStringBuffer(st);
      }
    }
  
    void nodeClone(MapNode n)
    {
      n._key = _key;
      n._val = _val;  
      n._red = _red;
    
      if(_left != null)
      {
        n._left = new MapNode(null, null);
        n._left._parent = n;
        _left.nodeClone(n._left);
      }
    
      if(_right != null)
      {
        n._right = new MapNode(null, null);
        n._right._parent = n;
        _right.nodeClone(n._right);
      }
    }
  }

  protected static class MapIterator
    extends    AbstractObjectPairIterator
    implements IObjectPairIterator
  {
    private MapNode         p = null;
    private AbstractTreeMap s = null; 
        
    MapIterator(AbstractTreeMap s)  
    {
      this.s = s;
      if(s._last == null) p = null; 
      else                p = s._last._frw;
    }
       
    MapIterator(MapIterator r)
    {
      s = r.s;
      p = r.p;
    }
    
    public boolean stop()
    {
      if(p != null) return false;
      else          return true;
    }
  
    public void shift()
    {
      if(p == s._last) p = null;
      else             p = p._frw;
    }
      
    public Object value1()
    {
      return p._key;
    }
    
    public Object value2()
    {
      return p._val;
    }
  
    public Object clone()
    {
      return new MapIterator(this);
    }
      
    public boolean equals(Object o)
    {
      if(!(o instanceof MapIterator)) return false;
      
      MapIterator r = (MapIterator)o;
       
      return r.s == s && r.p == p;
    }

    public int hashCode()
    {
      return s.hashCode() + 17*System.identityHashCode(p);
    }
    
    public void remove()
    {
      MapNode q = p;
      p = p._frw;
      if(p == s._last._frw) p = null;
      
      s.removeNode(q);
    }

    public void replaceObject1(Object o)
    {
      // TODO Auto-generated method stub
    }

    public void replaceObject2(Object o)
    {
      p._val = o;
    }
  }
}
