/*
 * Created on 19.05.2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package jatva.util;

import jatva.iterators.lang.AbstractObjectIterator;
import jatva.iterators.lang.IObjectIterator;

/**
 * @author Administrator
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public abstract class AbstractTreeSet
  extends AbstractSet
  implements ISet, Iterable
{
  abstract protected int     hash(Object o);
  abstract protected boolean equalObjects(Object o1, Object o2);
  abstract protected IList   makeList();

  abstract public    Object  clone();

  public AbstractTreeSet() {}

  public AbstractTreeSet(Object o)
  {
    _size = 1;
    _head = new SetNode(o);
    _head._bkw = _head._frw = _last = _head;   
  }
  
  public AbstractTreeSet(ISet s)
  {
    super(s);
  }

  public void clear()
  {
    _head = null;
    _size = 0;
    _last = null;
  }

  public int size()
  {
    return _size;
  }

  public boolean add(Object o)
  {
    if(_head == null)
    {
      _head = new SetNode(o);
      _head._red = false;
      _head._bkw = _head._frw = _last = _head;   
      _size++;
      
      return true;
    }
    
    SetNode p = _head, q;
    do
    {
      q = p;
      if(hash(p._o) == hash(o))     return false;
      else if(hash(p._o) > hash(o)) p = p._left;
      else                          p = p._right;
    }
    while(p != null);
    
    if(hash(q._o) > hash(o)) q._left = ( p =  new SetNode(o) );
    else                     q._right = ( p = new SetNode(o) );
    p._parent = q;
    
    _size++;
    p._frw = _last._frw;
    p._bkw = _last;
    _last._frw = p;
    _last = p;
    
    SetNode r;
    while(q != null && q._red == true)
    {
      if(q == q._parent._left)
      {
        r = q._parent._right;
        if(r == null || !r._red )
        {
          if(p == q._right)
          {
            q._right = p._left;
            if(p._left != null) p._left._parent = q;
            p._left = q;
            p._parent = q._parent;
            q._parent._left = p;
            q._parent = p;
            p = q;
            q = q._parent;
          }
          if(q._parent._parent != null)
          {
            if(q._parent._parent._left == q._parent) q._parent._parent._left = q;
            else                                     q._parent._parent._right = q;
          }
          else _head = q;
          
          q._red = false;
          q._parent._red = true;
          q._parent._left = q._right;
          if(q._right != null) q._right._parent = q._parent;
          q._right = q._parent;
          q._parent = q._parent._parent;
          q._right._parent = q;
          
          return true;
        }
        else
        {
          q._red = false;
          r._red = false;
          q._parent._red = true;
          p = q._parent;
          q = p._parent;
        }
      }
      else
      {
        r = q._parent._left;
        if(r == null || !r._red)
        {
          if(p == q._left)
          {
            q._left = p._right;
            if(p._right != null) p._right._parent = q;
            p._right = q;
            p._parent = q._parent;
            q._parent._right = p;
            q._parent = p;
            p = q;
            q = q._parent;
          }
          if(q._parent._parent != null)
          {
            if(q._parent._parent._left == q._parent) q._parent._parent._left = q;
            else                                     q._parent._parent._right = q;
          }
          else _head = q;
          
          q._red = false;
          q._parent._red = true;
          q._parent._right = q._left;
          if(q._left != null) q._left._parent = q._parent;
          q._left = q._parent;
          q._parent = q._parent._parent;
          q._left._parent = q;
          
          return true;
        }
        else
        {
          q._red = false;
          r._red = false;
          q._parent._red = true;
          p = q._parent;
          q = p._parent;
        }
      }
    }
    
    _head._red = false;
    return true;
  }

  public boolean contains(Object o)
  {
    if(_head == null) return false;
    
    SetNode p = _head;
    do
    {
      if(hash(p._o) == hash(o))     return true;
      else if(hash(p._o) > hash(o)) p = p._left;
      else                          p = p._right;
    }
    while(p != null);
    
    return false;
  }

  public boolean remove(Object o)
  {
    if(_head == null) return false;
    
    SetNode p = _head;
    do
    {
      if(hash(p._o) > hash(o))      p = p._left;
      else if(hash(p._o) < hash(o)) p = p._right;
      else                          break;
    }
    while(p != null);
    
    if(p == null) return false;
    
    removeNode(p);
    return true;
  }

  public IObjectIterator iterator()
  {
    return new SetIterator(this);
  }

  protected SetNode minNode()
  {
    if(_head == null) return null;
    else              return _head.min();
  }
  
  protected SetNode maxNode()
  {
    if(_head == null) return null;
    else              return _head.max();
  }
  
  protected SetNode nextNode(SetNode p)
  {
    if(p._right != null) return p._right.min();
    while(p._parent != null && p == p._parent._right) p = p._parent;
    return p._parent;
  }
  
  protected SetNode prevNode(SetNode p)
  {
    if(p._left != null) return p._left.max();
    while(p._parent != null && p == p._parent._left) p = p._parent;
    return p._parent;
  }

  protected void fixup(SetNode p, SetNode q, boolean isLeft)
  {
    while(p != null && ( q == null || q._red == false ) )
    {
      SetNode w, v;
      
      if(isLeft)
      {
        w = p._right;
        if(w._red)
        {
          w._red = false;
          p._red = true;
          rotate(true, p);
          w = p._right;
        }
        v = w._left;
        
        if(w._right == null || !w._right._red)
        {
          if(v == null || !v._red)
          {
            w._red = true;
            q = p;
            p = p._parent;
            isLeft = (p == null)?true:(q == p._left);
            continue;
          }
          else
          {
            w._red = true;
            v._red = false;
            rotate(false, w);
            w = v;
            v = v._left;
          }
        }
        
        w._red = p._red;
        p._red = false;
        if(w._right != null) w._right._red = false;
        rotate(true, p);
        
        q = _head;
        p = null;
      }
      else
      {
        w = p._left;
        if(w._red)
        {
          w._red = false;
          p._red = true;
          rotate(false, p);
          w = p._left;
        }
        v = w._right;
        
        if(w._left == null || !w._left._red)
        {
          if(v == null || !v._red)
          {
            w._red = true;
            q = p;
            p = p._parent;
            isLeft = (p == null)?true:(q == p._left);
            continue;
          }
          else
          {
            w._red = true;
            v._red = false;
            rotate(true, w);
            w = v;
            v = v._right;
          }
        }
        
        w._red = p._red;
        p._red = false;
        if(w._left != null) w._left._red = false;
        rotate(false, p);
        q = _head;
        p = null;
      }
    }
    
    if(q != null) q._red = false;
  }

  protected void rotate(boolean left, SetNode x)
  {
    SetNode y;
    if(left)
    {
      y = x._right;
      x._right = y._left;
      if(y._left != null) y._left._parent = x;
      
      y._parent = x._parent;
      if(x._parent != null)
      {
        if(x == x._parent._left) x._parent._left = y;
        else                     x._parent._right = y;
      }
      else _head = y;
      
      y._left = x;
      x._parent = y;
    }
    else
    {
      y = x._left;
      x._left = y._right;
      if(y._right != null) y._right._parent = x;
      
      y._parent = x._parent;
      if(x._parent != null)
      {
        if(x == x._parent._left) x._parent._left = y;
        else                     x._parent._right = y;
      }
      else _head = y;
      
      y._right = x;
      x._parent = y;
    }
  }
  
  protected void removeNode(SetNode p)
  {
    if(_size == 1)
    {
      _last = null;
      _head = null;
      _size--;
      
      return; 
    } 
    else
    { 
      p._bkw._frw = p._frw; 
      p._frw._bkw = p._bkw;
      if(p == _last) _last = p._bkw;
    }
    
    boolean isLeft;
    
    if(p._left == null)
    {
      if(p._parent == null) { _head = p._right; isLeft = true; }
      else
      {
        if(p == p._parent._left) { p._parent._left = p._right;  isLeft = true; }
        else                     { p._parent._right = p._right; isLeft = false; }
      }
      
      if(p._right != null) p._right._parent = p._parent;
      
      if(!p._red) fixup(p._parent, p._right, isLeft);
    }
    else if(p._right == null)
    {
      if(p._parent == null) { _head = p._left; isLeft = true; }
      else
      {
        if(p == p._parent._left) { p._parent._left = p._left;  isLeft = true; }
        else                     { p._parent._right = p._left; isLeft = false; }
      }
      
      p._left._parent = p._parent;
      if(!p._red) fixup(p._parent, p._left, isLeft);
    }
    else
    {
      SetNode q = nextNode(p);
      p._o = q._o;
      q._bkw._frw = p;
      q._frw._bkw = p;
      p._bkw = q._bkw;
      p._frw = q._frw;
      
      if(q._parent == null) { _head = q._right; isLeft = true; }
      else
      {
        if(q == q._parent._left) { q._parent._left = q._right;  isLeft = true; }
        else                     { q._parent._right = q._right; isLeft = false; }
      }
      
      if(q._right != null) q._right._parent = q._parent;
      
      if(!q._red) fixup(q._parent, q._right, isLeft); 
    }
    
    _size--;
    return;
  }

  SetNode _head;// = null;
  int     _size;// = 0;
  SetNode _last;// = null;
  
  protected static class SetNode
  {
    SetNode _bkw;
    SetNode _frw;
    SetNode _left;
    SetNode _right;
    SetNode _parent;
    Object  _o;
    boolean _red = true;
    
    SetNode(Object o) { _o = o; }
    
    SetNode min()
    {
      SetNode p = this;
      while(p._left != null) p = p._left;
      return p;
    }
    
    SetNode max()
    {
      SetNode p = this;
      while(p._right != null) p = p._right;
      return p;
    }
    
    boolean isChild(SetNode p)
    {
      if(p == null) return false;
      if(p == this) return true;
      if(_left != null && _left.isChild(p))   return true;
      if(_right != null && _right.isChild(p)) return true;
      return false;
    }
    
    int fill(Object array[], int ind)
    {
      int res = ind+1;
      array[ind] = _o;
    
      if(_left != null)
      {
        res = _left.fill(array, ind+1);
        if(_right != null) return _right.fill(array, res);
      }
      else if(_right != null) return _right.fill(array, ind+1);
      return res;
    }
  
    void appendStringBuffer(StringBuffer st)
    {
      st.append(_o);
      st.append("( " + ((_frw == null)?_frw:_frw._o) + " | " + ((_bkw == null)?_bkw:_bkw._o) + " )");
    
      if(_left != null)
      {
        st.append(", ");
        _left.appendStringBuffer(st);
      
        if(_right != null)
        {
          st.append(", ");
          _right.appendStringBuffer(st);
        }
      }
      else if(_right != null)
      {
        st.append(", ");
        _right.appendStringBuffer(st);
      }
    }
  
    void nodeClone(SetNode n)
    {
      n._o   = _o;
      n._red = _red;
    
      if(_left != null)
      {
        n._left = new SetNode(null);
        n._left._parent = n;
        _left.nodeClone(n._left);
      }
    
      if(_right != null)
      {
        n._right = new SetNode(null);
        n._right._parent = n;
        _right.nodeClone(n._right);
      }
    }
  }

  protected static class SetIterator
    extends    AbstractObjectIterator
    implements IObjectIterator
  {
    private SetNode         p = null;
    private AbstractTreeSet s = null; 
        
    SetIterator(AbstractTreeSet s)  
    {
      this.s = s;
      if(s._last == null) p = null; 
      else                p = s._last._frw;
    }
       
    SetIterator(SetIterator r)
    {
      s = r.s;
      p = r.p;
    }
    
    public boolean stop()
    {
      if(p == null) return true;
      else          return false;
    }
  
    public void shift()
    {
      if(p == s._last) p = null;
      else             p = p._frw;
    }
      
    public Object value()
    {
      return p._o;
    }
  
    public Object clone()
    {
      return new SetIterator(this);
    }
      
    public boolean equals(Object o)
    {
      if(!(o instanceof SetIterator)) return false;
      
      SetIterator r = (SetIterator)o;
       
      return r.s == s && r.p == p;
    }

    public int hashCode()
    {
      return s.hashCode() + 17*System.identityHashCode(p);
    }
    
    public void remove()
    {
      SetNode q = p;
      p = p._frw;
      if(p == s._last._frw) p = null;
      
      s.removeNode(q);
    }
  }
}
