/*
 * Copyright (c) 2004 ISP RAS.
 * 109004, B. Communisticheskaya, 25, Moscow, Russia.
 * All rights reserved.
 *
 * $Id: ISet.java,v 1.1 2005/05/12 03:53:23 kuliamin Exp $
 * Created on 30.04.2004
 *
 */
package jatva.util;

import jatva.iterators.lang.IObjectIterator;

/**
 * The interface of sets.
 *
 * @author Victor Kuliamin
 */
public interface ISet extends Cloneable
{
  void    clear();
  int     size();
  boolean isEmpty();

  boolean add(Object o);
  boolean addAll(ISet s);
  
  boolean contains(Object o);
  boolean containsRef(Object o);
  boolean containsAll(ISet s);
  boolean isSubset(ISet s);
  
  boolean remove(Object o);
  boolean removeAll(ISet s);
  
  boolean retain(ISet s);
  
  boolean replace(Object o1, Object o2);
  boolean replace(IMap m);

  IList toList();
  Object[] toArray();
  
  ISet power();

  IObjectIterator iterator();
  
  Object  clone();
  String  toString();
  boolean equals(Object o);
  boolean equalsByRefs(Object o);
  int     hashCode();
}
