/*
 * Copyright (c) 2004 ISP RAS.
 * 109004, B. Communisticheskaya, 25, Moscow, Russia.
 * All rights reserved.
 *
 * $Id: StringSet.java,v 1.1 2005/05/12 03:53:25 kuliamin Exp $
 * Created on 24.02.2005
 *
 */
package jatva.util;

/**
 * @author Victor Kuliamin
 */
public class StringSet
{
  StringSetNode _node = null;
  int _size = 0;
  
  public StringSet()
  {
  }
  
  public String ToString()
  {
    StringBuffer st = new StringBuffer("{");
    StringSetNode n = minimum_X();
    
    if(n != null)
    {
      st.append(n._value);
      n = next(n);
    }
    
    while(n != null)
    {
      st.append(", ");
      st.append(n._value);
      n = next(n);
    }
      
    st.append("}");
    
    return st.toString();
  }
  
  void rotate(boolean left, StringSetNode x)
  {
    StringSetNode y;
    
    if(left)
    {
      y = x._right;
      x._right = y._left;
      if(y._left != null)
        y._left._parent = x;
      
      y._parent = x._parent;
      if(x._parent != null)
      {
        if(x == x._parent._left)
          x._parent._left = y;
        else
          x._parent._right = y;
      }
      else
        _node = y;
      
      y._left = x;
      x._parent = y;
    }
    else
    {
      y = x._left;
      x._left = y._right;
      if(y._right != null)
        y._right._parent = x;
      
      y._parent = x._parent;
      if(x._parent != null)
      {
        if(x == x._parent._left)
          x._parent._left = y;
        else
          x._parent._right = y;
      }
      else
        _node = y;
      
      y._right = x;
      x._parent = y;
    }
  }
  
  public boolean contains(String value)
  {
    if(_node == null) return false;
    
    StringSetNode p = _node;
    int c;
    
    do
    {
      c = p._value.compareTo(value);
      if(c == 0)     return true;
      else if(c > 0) p = p._left;
      else           p = p._right;
    }
    while(p != null);
    
    return false;
  }
  
  StringSetNode minimum_X()
  {
    if(_node == null) return null;
    else              return _node.minimum_X();
  }

  public String minimum()
  {
    if(_node == null) return null;
    else              return minimum_X()._value;
  }
  
  StringSetNode maximum_X()
  {
    if(_node == null) return null;
    else              return _node.maximum_X();
  }
  
  public String maximum()
  {
    if(_node == null) return null;
    else              return maximum_X()._value;
  }
  
  StringSetNode next(StringSetNode p)
  {
    if(p._right != null) return p._right.minimum_X();
    
    while(p._parent != null && p == p._parent._right)
      p = p._parent;

    return p._parent;
  }
  
  StringSetNode prev(StringSetNode p)
  {
    if(p._left != null) return p._left.maximum_X();
    
    while(p._parent != null && p == p._parent._left)
      p = p._parent;

    return p._parent;
  }
  
  public boolean add(String value)
  {
    if(_node == null)
    {
      _node = new StringSetNode(value);
      _node._red = false;
      _size++;
      
      return true;
    }
    
    StringSetNode p = _node, q;
    int c;
    
    do
    {
      q = p;
      
      c = p._value.compareTo(value);
      if(c == 0)     return false;
      else if(c > 0) p = p._left;
      else           p = p._right;
    }
    while(p != null);
    
    if(q._value.compareTo(value) > 0)
         q._left  = ( p = new StringSetNode(value) );
    else q._right = ( p = new StringSetNode(value) );
    p._parent = q;
    
    _size++;
    
    StringSetNode r;
    
    while(q != null && q._red == true)
    {
      if(q == q._parent._left)
      {
        //        System.out.print("q is on the left, ");
        
        r = q._parent._right;
        if(r == null || !r._red )
        {
          if(p == q._right)
          {
            //            System.out.println("case 2");
                        
            q._right = p._left;
            if(p._left != null) p._left._parent = q;
            p._left = q;
            p._parent = q._parent;
            q._parent._left = p;
            q._parent = p;
            p = q;
            q = q._parent;
            
            //            System.out.println("After rotation : " + toString());
          }
          
          //          System.out.println("case 3");
          
          if(q._parent._parent != null)
          {
            if(q._parent._parent._left == q._parent) q._parent._parent._left  = q;
            else                                     q._parent._parent._right = q;
          }
          else _node = q;
          
          q._red = false;
          q._parent._red = true;
          q._parent._left = q._right;
          if(q._right != null) q._right._parent = q._parent;
          q._right = q._parent;
          q._parent = q._parent._parent;
          q._right._parent = q;
          
          return true;
        }
        else
        {
          //          System.out.println("case 1");
          
          q._red = false;
          r._red = false;
          q._parent._red = true;
          p = q._parent;
          q = p._parent;
        }
      }
      else
      {
        //        System.out.print("q is on the right, ");

        r = q._parent._left;
        if(r == null || !r._red)
        {
          if(p == q._left)
          {
            //            System.out.println("case 2");

            q._left = p._right;
            if(p._right != null) p._right._parent = q;
            p._right = q;
            p._parent = q._parent;
            q._parent._right = p;
            q._parent = p;
            p = q;
            q = q._parent;

            //            System.out.println("After rotation : " + toString());
          }
          
          //         System.out.println("case 3");
         
          if(q._parent._parent != null)
          {
            if(q._parent._parent._left == q._parent) q._parent._parent._left  = q;
            else                                     q._parent._parent._right = q;
          }
          else _node = q;
          
          q._red = false;
          q._parent._red = true;
          q._parent._right = q._left;
          if(q._left != null) q._left._parent = q._parent;
          q._left = q._parent;
          q._parent = q._parent._parent;
          q._left._parent = q;
          
          return true;
        }
        else
        {
          q._red = false;
          r._red = false;
          q._parent._red = true;
          p = q._parent;
          q = p._parent;
        }
      }
    }
    
    _node._red = false;
    
    return true;
  }
  
  public boolean remove(String value)
  {
    if(_node == null) return false;
    StringSetNode p = _node;
    int c;
    
    do
    {
      c = p._value.compareTo(value);
      if(c > 0)      p = p._left;
      else if(c < 0) p = p._right;
      else           break;
    }
    while(p != null);
    
    if(p == null) return false;
    
    boolean isLeft;
    
    if(p._left == null)
    {
      if(p._parent == null)
      {
        _node = p._right;
        isLeft = true;
      }
      else
      {
        if(p == p._parent._left)
        {
          p._parent._left = p._right;
          isLeft = true;
        }
        else
        {
          p._parent._right = p._right;
          isLeft = false;
        }
      }
      
      if(p._right != null) p._right._parent = p._parent;
      if(!p._red)          fixup(p._parent, p._right, isLeft);
    }
    else if(p._right == null)
    {
      if(p._parent == null)
      {
        _node = p._left;
        isLeft = true;
      }
      else
      {
        if(p == p._parent._left)
        {
          p._parent._left = p._left;
          isLeft = true;
        }
        else
        {
          p._parent._right = p._left;
          isLeft = false;
        }
      }
      
      p._left._parent = p._parent;
      if(!p._red) fixup(p._parent, p._left, isLeft);
    }
    else
    {
      StringSetNode q = next(p);
      p._value = q._value;
      
      if(q._parent == null)
      {
        _node = q._right;
        isLeft = true;
      }
      else
      {
        if(q == q._parent._left)
        {
          q._parent._left = q._right;
          isLeft = true;
        }
        else
        {
          q._parent._right = q._right;
          isLeft = false;
        }
      }
      
      if(q._right != null) q._right._parent = q._parent;
      if(!q._red)          fixup(q._parent, q._right, isLeft); 
    }
    
    _size--;
    return true;
  }
  
  void fixup(StringSetNode p, StringSetNode q, boolean isLeft)
  {
    while(p != null && ( q == null || q._red == false ) )
    {
      StringSetNode w, v;
      
      if(isLeft)
      {
        w = p._right;
        if(w._red)
        {
          w._red = false;
          p._red = true;
          rotate(true, p);
          w = p._right;
        }
        
        v = w._left;
        
        if(w._right == null || !w._right._red)
        {
          if(v == null || !v._red)
          {
            w._red = true;
            
            q = p;
            p = p._parent;
            isLeft = (p == null)?true:(q == p._left);
            
            continue;
          }
          else
          {
            w._red = true;
            v._red = false;
            rotate(false, w);
            
            w = v;
            v = v._left;
          }
        }
        
        w._red = p._red;
        p._red = false;
        if(w._right != null) w._right._red = false;
        rotate(true, p);
        
        q = _node;
        p = null;
      }
      else
      {
        w = p._left;
        if(w._red)
        {
          w._red = false;
          p._red = true;
          rotate(false, p);
          w = p._left;
        }
        
        v = w._right;
        
        if(w._left == null || !w._left._red)
        {
          if(v == null || !v._red)
          {
            w._red = true;
            
            q = p;
            p = p._parent;
            isLeft = (p == null)?true:(q == p._left);
            
            continue;
          }
          else
          {
            w._red = true;
            v._red = false;
            rotate(true, w);
            
            w = v;
            v = v._right;
          }
        }
        
        w._red = p._red;
        p._red = false;
        if(w._left != null) w._left._red = false;
        rotate(false, p);
        
        q = _node;
        p = null;
      }
    }
    
    if(q != null) q._red = false;
  }
  
  public void clear()
  {
    _node = null;
    _size = 0;
  }
  
  public boolean isEmpty()
  {
    return (_node == null);
  }
  
  public boolean equals(Object o)
  {
    if(!(o instanceof StringSet)) return false;
    StringSet r = (StringSet)o;
    if(_size != r._size) return false;
    if(r == this)        return true;
            
    StringSetNode p = minimum_X(), q = r.minimum_X();
    
    while(p != null)
    {
      if(p._value != q._value) return false;
      p = next(p);
      q = r.next(q);
    }
    
    return true;
  }

  public int hashCode()
  {
    int res = 0;
    StringSetNode p = minimum_X();

    while(p != null)
    {
      res += p._value.hashCode();
      p = next(p);
    }
    
    return res;
  }
  
  public int size()
  {
    return _size;
  }
  
  public String[] toArray()
  {
    String[] result = new String[_size];

    StringSetNode p = minimum_X();

    for(int i = 0; i < _size; i++)
    {
      result[i] = p._value;
      p = next(p);
    }

    return result;
  }
  
  public StringSet(StringSet r)
  {
    _size = r._size;
    
    if(r._node != null)
    {
      _node = new StringSetNode(null);
      r._node.nodeClone(_node);
    }
  }
  
  public Object clone()
  {
    return new StringSet(this);
  }

  public StringSetEnumerator getEnumerator()
  {
    return new StringSetEnumerator(this);
  }

  public class StringSetEnumerator
  {
    StringSet _base = null;
    StringSetNode _current = null;

    public StringSetEnumerator(StringSet s)
    {
      _base = s;
    }

    public String current()
    {
      return _current._value;
    }

    public boolean moveNext()
    {
      StringSetNode q = null;
      if(_current == null && _base._node == null)  return false;
      else if(_current == null)                    { _current = _base.minimum_X(); return true; }
      else if((q = _base.next(_current)) == null) { _current = null; return false; }
      else                                         { _current = q; return true; }
    }
  }

  protected class StringSetNode
  {
    public StringSetNode _left = null;
    public StringSetNode _right = null;
    public StringSetNode _parent = null;
    public String _value = null;
    public boolean _red = true;
  
    public StringSetNode(String value)
    {
      _value = value;
    }
  
    public StringSetNode minimum_X()
    {
      StringSetNode p = this;
    
      while(p._left != null) p = p._left;
    
      return p;
    }

    public StringSetNode maximum_X()
    {
      StringSetNode p = this;
    
      while(p._right != null) p = p._right;
    
      return p;
    }
  
    public void nodeClone(StringSetNode n)
    {
      n._value = _value;
      n._red = _red;
    
      if(_left != null)
      {
        n._left = new StringSetNode(null);
        n._left._parent = n;
        _left.nodeClone(n._left);
      }
    
      if(_right != null)
      {
        n._right = new StringSetNode(null);
        n._right._parent = n;
        _right.nodeClone(n._right);
      }
    }
  }
}

