/*
 * Created on 24.05.2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package jatva.util;

import jatva.lang.InsufficientAccessibilityError;
import jatva.lang.TranslationError;

import java.lang.reflect.Array;
import java.lang.reflect.Constructor;
import java.lang.reflect.Field;
import java.lang.reflect.Method;
import java.lang.reflect.Modifier;
import java.util.Iterator;

/**
 * @author Administrator
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class Utils
{
  public static String endl = System.getProperty("line.separator");

  /**
   * Returns string representation of the specified
   * object as it is returned by <code>Object.toString()</code>
   * method.
   *
   * @param o    The object
   * @return
   */
  public static String getSimpleString(Object o)
  {
    if(o == null) return "null";

    StringBuffer buf = new StringBuffer();
    Class t = o.getClass();
    while(t.isArray()) { buf.append("[]"); t = t.getComponentType(); }
    buf.insert(0, t.getName());
    buf.append('@');
    buf.append(Integer.toHexString(System.identityHashCode(o)));
    return buf.toString();
  }

  public static String getSimpleString(boolean o)
  {
    return Boolean.toString(o);
  }

  public static String getSimpleString(char o)
  {
    return Character.toString(o);
  }

  public static String getSimpleString(byte o)
  {
    return Byte.toString(o);
  }

  public static String getSimpleString(short o)
  {
    return Short.toString(o);
  }

  public static String getSimpleString(int o)
  {
    return Integer.toString(o);
  }

  public static String getSimpleString(long o)
  {
    return Long.toString(o);
  }

  public static String getSimpleString(float o)
  {
    return Float.toString(o);
  }

  public static String getSimpleString(double o)
  {
    return Double.toString(o);
  }

  public static String getArraySimpleString(Object[] o)
  {
    if(o == null) return "null";

    StringBuffer s = new StringBuffer("[");

    for(int i = 0; i < o.length; i++)
    {
      if(i > 0) s.append(", ");
      s.append(getSimpleString(o[i]));
    }

    s.append(']');
    return s.toString();
  }


  public static String  getFieldsString(Object o)
  {
    StringBuffer buf = new StringBuffer(getSimpleString(o));
    Class c = o.getClass();
    if(c.isArray())                            { buf.append(":"); appendFieldsStringWithArray(o, c, buf); }
    else if(o instanceof java.util.List)       { buf.append(":"); appendFieldsStringWithList((java.util.List)o, buf); }
    else if(o instanceof java.util.Map)        { buf.append(":"); appendFieldsStringWithMap((java.util.Map)o, buf); }
    else if(o instanceof java.util.Collection) { buf.append(":"); appendFieldsStringWithCollection((java.util.Collection)o, buf); }
    else if(o instanceof Class)                { buf.append(":"); appendFieldsStringWithClass((Class)o, buf); }
    else
    {
      Class[] cls = new Class[]{};
      Method mth1 = null, mth2 = null;
      try
      {
        mth1 = c.getMethod("toString", cls);
        mth2 = Class.forName("java.lang.Object").getMethod("toString", cls);
      }
      catch (Throwable e) { }

      if(mth2.equals(mth1)) { buf.append(':'); appendFieldsStringWithFields(o, c, buf); }
      else { buf.append(':'); buf.append(o.toString()); }
    }

    return buf.toString();
  }

  private static void appendFieldsStringWithArray(Object o, Class c, StringBuffer s)
  {
    if(o == null) { s.append("null"); return; }

    int l = Array.getLength(o);
    int j = 0;

    s.append("[ ");

    if(!c.getComponentType().isArray())
    {
      c = c.getComponentType();
      if(c.isPrimitive())
      {
        if(c.equals(Boolean.TYPE))
          for(; j < l; j++) { if(j != 0) s.append(", "); s.append(Array.getBoolean(o, j)); }
        else if(c.equals(Character.TYPE))
          for(; j < l; j++) { if(j != 0) s.append(", "); s.append(Array.getChar(o, j));    }
        else if(c.equals(Byte.TYPE))
          for(; j < l; j++) { if(j != 0) s.append(", "); s.append(Array.getByte(o, j));    }
        else if(c.equals(Short.TYPE))
          for(; j < l; j++) { if(j != 0) s.append(", "); s.append(Array.getShort(o, j));   }
        else if(c.equals(Integer.TYPE))
          for(; j < l; j++) { if(j != 0) s.append(", "); s.append(Array.getInt(o, j));     }
        else if(c.equals(Long.TYPE))
          for(; j < l; j++) { if(j != 0) s.append(", "); s.append(Array.getLong(o, j));    }
        else if(c.equals(Float.TYPE))
          for(; j < l; j++) { if(j != 0) s.append(", "); s.append(Array.getFloat(o, j));   }
        else if(c.equals(Double.TYPE))
          for(; j < l; j++) { if(j != 0) s.append(", "); s.append(Array.getDouble(o, j));  }
        else// if(cl.equals(Void.TYPE))
          for(; j < l; j++) { if(j != 0) s.append(',');                                     }
      }
      else
        for(; j < l; j++)   { if(j != 0) s.append(", "); s.append( getSimpleString(Array.get(o, j)) ); }
    }
    else
      for(; j < l; j++)     { if(j != 0) s.append(", "); appendFieldsStringWithArray(Array.get(o, j), c.getComponentType(), s); }

    s.append(" ]");

  }

  private static void appendFieldsStringWithList(java.util.List l, StringBuffer s)
  {
    s.append("[ ");
    for(int i = 0; i < l.size(); i++)
    {
      if(i > 0) s.append(", ");
      s.append(getSimpleString(l.get(i)));
    }
    s.append(" ]");
  }

  private static void appendFieldsStringWithMap(java.util.Map m, StringBuffer s)
  {
    s.append("{ ");
    boolean first = true;
    for(Iterator i = m.keySet().iterator(); i.hasNext(); )
    {
      Object k = i.next();
      if(!first) s.append(", ");
      first = false;
      s.append("( ");
      s.append( getSimpleString(k) );
      s.append(" : ");
      s.append( getSimpleString(m.get(k)));
      s.append(" )");
    }
    s.append(" } ");
  }

  private static void appendFieldsStringWithCollection(java.util.Collection c, StringBuffer s)
  {
    s.append("{ ");
    boolean first = true;
    for(Iterator i = c.iterator(); i.hasNext(); )
    {
      if(!first) s.append(", ");
      first = false;
      s.append( getSimpleString(i.next()));
    }
    s.append(" }");
  }

  private static void appendFieldsStringWithClass(Class t, StringBuffer s)
  {
    int l = s.length();
    while(t.isArray()) { s.append("[]"); t = t.getComponentType(); }
    s.insert(l, t.getName());
  }

  private static void appendFieldsStringWithFields(Object o, Class c, StringBuffer s)
  {
    Field[] ff;

    s.append("{ ");
    boolean flag = false;

    try
    {
      while(c != null)
      {
        ff = c.getDeclaredFields();
        for(int i = 0; i < ff.length; i++)
        {
          if(Modifier.isStatic(ff[i].getModifiers())) continue;

          ff[i].setAccessible(true);

          if(flag) s.append(", ");
          flag = true;

          s.append(ff[i].getName()).append(" = ");

          Class t = ff[i].getType();
          Object fv = ff[i].get(o);

          if(t.isPrimitive()) { s.append(fv); }
          else
          {
            s.append(getSimpleString(fv));

            if(t.isArray())                             { s.append(":"); appendFieldsStringWithArray(fv, t, s); }
            else if(fv instanceof java.util.List)       { s.append(":"); appendFieldsStringWithList((java.util.List)fv, s); }
            else if(fv instanceof java.util.Map)        { s.append(":"); appendFieldsStringWithMap((java.util.Map)fv, s); }
            else if(fv instanceof java.util.Collection) { s.append(":"); appendFieldsStringWithCollection((java.util.Collection)fv, s); }
          }
        }

        c = c.getSuperclass();
      }
    }
    catch (Throwable e)
    {
    }

    s.append(" }");
  }


  public static String getFieldsString(boolean o)
  {
    return Boolean.toString(o);
  }

  public static String getFieldsString(char o)
  {
    return Character.toString(o);
  }

  public static String getFieldsString(byte o)
  {
    return Byte.toString(o);
  }

  public static String getFieldsString(short o)
  {
    return Short.toString(o);
  }

  public static String getFieldsString(int o)
  {
    return Integer.toString(o);
  }

  public static String getFieldsString(long o)
  {
    return Long.toString(o);
  }

  public static String getFieldsString(float o)
  {
    return Float.toString(o);
  }

  public static String getFieldsString(double o)
  {
    return Double.toString(o);
  }



  public static int hash(Object o)
  {
    if(o == null) return 0;
    else          return o.hashCode();
  }

  public static boolean equalObjects(Object o1, Object o2)
  {
    return o1 == null && o2 == null || o1 != null && o1.equals(o2);
  }

  public static int identityHash(Object o)
  {
    return System.identityHashCode(o);
  }

  public static boolean sameObjects(Object o1, Object o2)
  {
    return o1 == o2;
  }

  public final static int toInteger(Object o)
  {
    return ((Integer)o).intValue();
  }

  public final static byte toByte(Object o)
  {
    return ((Byte)o).byteValue();
  }

  public final static char toCharacter(Object o)
  {
    return ((Character)o).charValue();
  }

  public final static short toShort(Object o)
  {
    return ((Short)o).shortValue();
  }

  public final static long toLong(Object o)
  {
    return ((Long)o).longValue();
  }

  public final static boolean toBoolean(Object o)
  {
    return ((Boolean)o).booleanValue();
  }

  public final static float toFloat(Object o)
  {
    return ((Float)o).floatValue();
  }

  public final static double toDouble(Object o)
  {
    return ((Double)o).doubleValue();
  }

  public final static Object toObject(int v)
  {
    return new Integer(v);
  }

  public final static Object toObject(boolean v)
  {
    return new Boolean(v);
  }

  public final static Object toObject(byte v)
  {
    return new Byte(v);
  }

  public final static Object toObject(short v)
  {
    return new Short(v);
  }

  public final static Object toObject(char v)
  {
    return new Character(v);
  }

  public final static Object toObject(long v)
  {
    return new Long(v);
  }

  public final static Object toObject(float v)
  {
    return new Float(v);
  }

  public final static Object toObject(double v)
  {
    return new Double(v);
  }

  public final static Method getMethodByStringPrefix( String mth )
  {
      String class_name = getClassFromMethodSignature( mth );
      Class<?> clazz = null;
      try
      {
          clazz = Class.forName( class_name );
      }
      catch( ClassNotFoundException e )
      {
          throw new TranslationError( "Invalid method signature: no declaring class"
                                    , new String[]{ "method signature" }
                                    , new String[]{ mth }
                                    );
      }
      return getMethodByStringPrefix( clazz, mth );
  }

  /**
   * Searches the given class for the method which reflection string representation
   * equals to the given one in the following sense: from both method strings (mth parameter
   * and each method from cls class) the parts consisting of class name and parameter type are
   * Thus only those parts of the signatures are compared which are meaningful from Java semantics point of view.
   */
  public final static Method getMethodByStringPrefix(Class cls, String mth)
  {
    Method[] mths = null;

    int s = mth.lastIndexOf(' ', mth.indexOf('('));
    int p = 0;
    int l = mth.indexOf(')')-s;
    String m = null;

    try
    {
      mths = cls.getDeclaredMethods();
    }
    catch(SecurityException ex)
    {
      throw new InsufficientAccessibilityError(   "Insufficient rights to find a method through reflection"
                                                , ex
                                                , new String[]{"class", "method"}
                                                , new String[]{cls.getName(), mth}
                                               );
    }

    for(int i = 0; i < mths.length; i++)
    {
      m = mths[i].toString();
      p = m.lastIndexOf(' ', m.indexOf('('));

      if(m.regionMatches(p+1, mth, s+1, l))
      {
        //System.out.println(" i-th METHOD FROM UTILS: " + mths[i]);

        return mths[i];
      }
    }

    return null;
  }

  public final static Constructor<?> getConstructorByPartialSignature( String ps )
  {
      String class_name = getDeclaringClassName( ps );
      String par_types = ps.substring( ps.indexOf( '(' ) + 1, ps.lastIndexOf( ')' ) );

      Class<?> clazz = null;
      try
      {
          clazz = Class.forName( class_name );
      }
      catch( ClassNotFoundException e )
      {
          throw new TranslationError( "Invalid constructor signature: no declaring class"
                                    , new String[]{ "ctor signature" }
                                    , new String[]{ ps }
                                    );
      }

      Constructor<?>[] ctors = null;

      try
      {
        ctors = clazz.getDeclaredConstructors();
      }
      catch(SecurityException ex)
      {
        throw new InsufficientAccessibilityError(  "Insufficient rights to find a constructor through reflection"
                                                , ex
                                                , new String[]{"class", "constructor"}
                                                , new String[]{ class_name, ps}
                                                );
      }

      for(int i = 0; i < ctors.length; i++)
      {
        Constructor<?> ctor = ctors[ i ];
        String ctor_str = ctor.toString();
        String ctor_par_types = ctor_str.substring( ctor_str.indexOf( '(' ) + 1
                                                  , ctor_str.lastIndexOf( ')' )
                                                  );
        if( ctor_par_types.equals( par_types ) )
            return ctor;
        // if(ctors[i].toString().startsWith(ctor)) return ctors[i];
      }

      return null;
  }

  private final static StringSet _primeTypes = new StringSet();
  static
  {
    _primeTypes.add("boolean");
    _primeTypes.add("byte");
    _primeTypes.add("short");
    _primeTypes.add("char");
    _primeTypes.add("int");
    _primeTypes.add("long");
    _primeTypes.add("float");
    _primeTypes.add("double");
  }

  public final static boolean isPrimitiveType(String type)
  {
    return _primeTypes.contains(type);
  }

  public final static boolean isVoidType(String type)
  {
    return "void".equals(type);
  }

  public final static String getResultType(String sig)
  {
    int i = sig.lastIndexOf(' ', sig.indexOf('('));
    return sig.substring(sig.lastIndexOf(' ', i-1)+1, i);
  }

  public final static String getConstructorResultType(String sig)
  {
    int i = sig.indexOf('(');
    return sig.substring(sig.lastIndexOf(' ', i-1)+1, i);
  }

  /**
   * Calculates parameter types from the reflect signature
   */
  public final static String[] getParameterTypes(String sig)
  {
      int opening_brace = sig.indexOf( '(' );

      if( opening_brace == sig.length() - 2 )
          return new String[]{};

      String parstring = sig.substring( opening_brace + 1, sig.length() - 1 );
      return parstring.split( "," );
  }

  public final static String[] getParameterTypes(int n, String sig)
  {
    String[] res = new String[n];

    int k = sig.indexOf('('), l, m;

    for(int i = 0; i < n; i++)
    {
      l = sig.indexOf(',', k+1);
      m = sig.indexOf(')', k);

      if(l == -1 || l > m) l = m;
      if(m == -1) return res;

      res[i] = sig.substring(k+1, l);
      k = l;
    }

    return res;
  }

  /**
   * returns the name of the class that declared the given executable
   * whether it's method or constructor.
   */
  public final static String getDeclaringClassName( String sig )
  {
      sig = cropModifiers( sig );

      int opening_brace = sig.indexOf( '(' );
      int last_space = sig.lastIndexOf( ' ', opening_brace );

      if( last_space == -1 )
      {
          // it's a ctor (no return type)
          return sig.substring( 0, opening_brace );
      } else {
          return sig.substring( last_space + 1, opening_brace );
      }
  }

  public final static String getClassFromMethodSignature( String sig )
  {
      sig = cropModifiers( sig );
      int opening_brace = sig.indexOf( '(' );
      int last_space = sig.lastIndexOf( ' ', opening_brace );
      sig = sig.substring( last_space + 1, opening_brace );
      int last_dot = sig.lastIndexOf( '.' );
      return sig.substring( 0, last_dot );
  }

  public final static String getMethodName(String sig)
  {
    int i = sig.indexOf('(');
    return sig.substring(sig.lastIndexOf('.', i-1)+1, i);
  }

  public final static String glueClassAndMethod(String cls, String mth)
  {
    StringBuffer s = new StringBuffer(mth);
    int i = mth.lastIndexOf('.', mth.indexOf('('));
    int j = mth.lastIndexOf(' ', i-1)+1;

    s.replace(j, i, cls);
    return s.toString();
  }

  public final static String cropModifiers(String sig) {
      int bracepos = sig.indexOf('(');
      int spacepos = sig.indexOf(' ');
      if (spacepos == -1 || spacepos > bracepos) {
          return sig;
      }

      String word = sig.substring(0, spacepos);
      if ("public".equals(word) || "protected".equals(word) || "private".equals(word)
              || "abstract".equals(word) || "static".equals(word) || "final".equals(word)
              || "synchronized".equals(word)|| "native".equals(word) || "strictfp".equals(word)) {
          return cropModifiers(sig.substring(spacepos + 1));
      }

      return sig;
  }


  public static final String prettifyClass( Class<?> clazz )
  {
      String class_name = clazz.getCanonicalName();
      if( class_name == null )
          class_name = clazz.getName();

      return prettifyClass( class_name );
  }

  public static final String prettifyClass( String clazz_name )
  {
      return clazz_name.replace( '$', '.' );
  }

  public static String appendCommentToFailure( String info, String comment )
  {
      return info + ":" + endl + comment;
  }
}
